﻿* Encoding: UTF-8.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// BIFIE SPSS-Makros, v1.8 - 5. März 2020.
*///// Konrad Oberwimmer, k.oberwimmer@bifie.at.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Hilfsmakros.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_compjkrep (jkzone = !charend("/")/
                           jkwgt = !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           rwgtbase = !charend("/")/
                           dual = !default(0) !charend("/")).

!IF (nrep>1) !THEN
	!IF (!dual < 1) !THEN
   		!DO !cnt = 1 !TO !nrep
      		COMPUTE !CONCAT(!rwgtbase,!cnt) = !wgt.
      		IF (!jkzone=!cnt) !CONCAT(!rwgtbase,!cnt) = 2 * !jkwgt * !wgt.
   		!DOEND
   	!IFEND
   	!IF (!dual >= 1) !THEN
    	!DO !cnt = 1 !TO !dual
      		COMPUTE !CONCAT(!rwgtbase,!cnt) = !wgt.
      		IF (!jkzone=!cnt) !CONCAT(!rwgtbase,!cnt) = 2 * !jkwgt * !wgt.
   	  	!DOEND
   	  	!DO !cnt = 1 !TO !dual
   	  		!LET !repnumber = !LENGTH(!CONCAT(!BLANKS(!cnt),!BLANKS(!dual)))
   	  		COMPUTE !CONCAT(!rwgtbase,!repnumber) = !wgt.
      		IF (!jkzone=!cnt) !CONCAT(!rwgtbase,!repnumber) = 2 * (1 - !jkwgt) * !wgt.
   	  	!DOEND
   	!IFEND
   EXECUTE.
!IFEND

!ENDDEFINE.

DEFINE !mcr_bifie_openfile (path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           allinone = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           wgt = !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           nrep = !charend("/")/
                           rwgtbase = !charend("/")/
                           sel = !charend("/")).

PRESERVE.
DATASET NAME mcr_bifie_prev.

!IF (!debug='yes') !THEN
   SET MPRINT ON.
   SET PRINTBACK ON.
!IFEND
!IF (!debug~='yes') !THEN
  OMS /SELECT ALL EXCEPT = [TABLES]
    /DESTINATION VIEWER = NO 
    /TAG = 'KeepQuiet'.
  OMS /SELECT TABLES
    /IF SUBTYPES='Case Processing Summary'
    /DESTINATION VIEWER=NO
    /TAG = 'NoCaseProcessing'.
!IFEND

!IF (!path~=!NULL) !THEN
   CD !QUOTE(!path).
!IFEND

!LET !filename = !file
!IF (!INDEX(!filename,"$")~=0) !THEN
   !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!filename,'$')), 2))
   !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!filename,'$')), !BLANKS(1)))
   !IF (!LENGTH(!filename)>!afterSign) !THEN
      !LET !filename = !CONCAT(!SUBSTR(!filename,1,!beforeSign),'1',!SUBSTR(!filename,!afterSign))
   !ELSE
      !LET !filename = !CONCAT(!SUBSTR(!filename,1,!beforeSign),'1')
   !IFEND
!IFEND
!IF (!INDEX(!filename,".sav")=0) !THEN !LET !filename = !CONCAT(!filename,".sav") !IFEND
GET FILE=!QUOTE(!filename).

!IF (!jkzone~=!NULL) !THEN
   !mcr_bifie_compjkrep
      jkzone = !jkzone/
      jkwgt = !jkwgt/
      wgt = !wgt/
      nrep = !nrep/
      rwgtbase = !rwgtbase/
      dual = !repdual/.
!IFEND

!IF (!sel~=!NULL) !THEN
   COMPUTE mcr_bifie_selfilter = !sel.
   SELECT IF mcr_bifie_selfilter.
   EXECUTE.
!IFEND

DATASET NAME mcr_bifie_data.

!ENDDEFINE.

DEFINE !mcr_bifie_addmifiles (file = !charend("/")/
                           nmi = !charend("/")/
                           sel = !charend("/")/
                           allinone = !default("no") !charend("/")/
                           wgt = !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           nrep = !charend("/")/
                           rwgtbase = !charend("/")/
                           vars = !charend("/")).

DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
!IF (!nmi > 1 !AND !allinone~='yes') !THEN
   NUMERIC mcr_bifie_micnt (F4.0).
   COMPUTE mcr_bifie_micnt = 1.
   EXECUTE.
   !DO !cnt = 2 !TO !nmi
      !LET !filename = !file
      !IF (!INDEX(!filename,"$")~=0) !THEN
         !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!filename,'$')), 2))
         !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!filename,'$')), !BLANKS(1)))
         !IF (!LENGTH(!filename)>!afterSign) !THEN
            !LET !filename = !CONCAT(!SUBSTR(!filename,1,!beforeSign),!cnt,!SUBSTR(!filename,!afterSign))
         !ELSE
            !LET !filename = !CONCAT(!SUBSTR(!filename,1,!beforeSign),!cnt)
         !IFEND
      !IFEND
      !IF (!INDEX(!filename,".sav")=0) !THEN !LET !filename = !CONCAT(!filename,".sav") !IFEND
      GET FILE=!QUOTE(!filename).
      DATASET NAME mcr_univar_newdata.
      !IF (!jkzone~=!NULL) !THEN
         !mcr_bifie_compjkrep
            jkzone = !jkzone/
            jkwgt = !jkwgt/
            wgt = !wgt/
            nrep = !nrep/
            rwgtbase = !rwgtbase/
            dual = !repdual/.
      !IFEND
      !IF (!sel~=!NULL) !THEN
         COMPUTE mcr_bifie_selfilter = !sel.
         SELECT IF mcr_bifie_selfilter.
         EXECUTE.
      !IFEND
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      ADD FILES FILE=* /FILE=mcr_univar_newdata.
      DATASET CLOSE mcr_univar_newdata.
      IF (MISSING(mcr_bifie_micnt)) mcr_bifie_micnt = !cnt.
      EXECUTE.
   !DOEND
!IFEND
!IF (!nmi > 1 !AND !allinone='yes') !THEN
   COMPUTE mcr_bifie_tmp = 1.
   EXECUTE.
   VARSTOCASES
      /MAKE mcr_bifie_tmp1 FROM !DO !cnt = 1 !TO !nmi mcr_bifie_tmp !DOEND
      !DO !var !IN (!vars)
         !IF (!INDEX(!var,'$')~=0) !THEN
            !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!var,'$')), 2))
            !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!var,'$')), !BLANKS(1)))
            !IF (!afterSign > !LENGTH(!var)) !THEN
               !LET !oneplain = !SUBSTR(!var,1,!beforeSign)
            !ELSE
               !LET !oneplain = !CONCAT(!SUBSTR(!var,1,!beforeSign),!SUBSTR(!var,!afterSign))
            !IFEND
            !LET !onelist = !NULL
            !DO !cnt = 1 !TO !nmi
               !IF (!afterSign > !LENGTH(!var)) !THEN
                  !LET !onelist = !CONCAT(!onelist,' ',!CONCAT(!SUBSTR(!var,1,!beforeSign),!cnt))
               !ELSE   
                  !LET !onelist = !CONCAT(!onelist,' ',!CONCAT(!SUBSTR(!var,1,!beforeSign),!cnt,!SUBSTR(!var,!afterSign)))
               !IFEND
            !DOEND
            /MAKE !oneplain FROM !onelist
         !IFEND
      !DOEND
      /INDEX=mcr_bifie_micnt
      .
!IFEND

!ENDDEFINE.

DEFINE !mcr_bifie_calcsampvar (nrep = !charend("/")/
                           method = !charend("/")/
                           fay = !charend("/")/
                           coeffs = !charend("/")).

DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
!IF (!nrep>1) !THEN
      *Rechne in quadrierte Abweichungen vom finalen Schaetzer um.
   !DO !coeff !IN (!coeffs)
      !DO !cnt = 1 !TO !nrep
         COMPUTE !CONCAT(!coeff,'_rep',!cnt) = (!coeff - !CONCAT(!coeff,'_rep',!cnt)) ** 2.
      !DOEND
   !DOEND
   EXECUTE.
   *Summiere quadrierte Abweichungen.
   !DO !coeff !IN (!coeffs)
   */// Begin Summenbildung. ///*.
      COMPUTE !CONCAT(!coeff,'_varrep')=SUM(
         !DO !cnt = 1 !TO !nrep
            !IF (!cnt>1) !THEN
               ,
            !IFEND
            !CONCAT(!coeff,"_rep",!cnt)
         !DOEND
         ).
   */// Ende Summenbildung. ///*.
   !DOEND
   EXECUTE.
   !IF (!method='BRR' !AND !fay~=!NULL) !THEN
      !DO !coeff !IN (!coeffs)      
         COMPUTE !CONCAT(!coeff,'_varrep') = ((1 / !nrep / (!fay ** 2)) * !CONCAT(!coeff,'_varrep')).
         EXECUTE.
      !DOEND
   !IFEND
   !IF (!method='JKK' !AND !fay~=!NULL) !THEN
      !DO !coeff !IN (!coeffs)      
         COMPUTE !CONCAT(!coeff,'_varrep') = !fay * !CONCAT(!coeff,'_varrep').
         EXECUTE.
      !DOEND
   !IFEND
!ELSE
   *Erstelle leere VarRep-Variable.
   !DO !coeff !IN (!coeffs)
      COMPUTE !CONCAT(!coeff,'_varrep') = $SYSMIS.
      EXECUTE.
   !DOEND
!IFEND

!ENDDEFINE.

DEFINE !mcr_bifie_calcmivar (nmi = !charend("/")/
                           nrep = !charend("/")/
                           quick = !default('n') !charend("/")/
                           coeffs = !charend("/")/
                           breakvars = !charend("/")).

!IF (!nmi>1) !THEN
   DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
   !IF (!breakvars~=!NULL) !THEN
      SORT CASES BY !breakvars.
   !IFEND
   * Bilde zunaechst den Schaetzer durch Mittelung der MI-Ergebnisse. Weil evt. 0-Werte (bei Zaehlungen) fehlen, wird das mit Summe/NMI gemacht.
   AGGREGATE
      /OUTFILE=* MODE=ADDVARIABLES
      !IF (!breakvars~=!NULL) !THEN
         /PRESORTED
         /BREAK=!breakvars
      !IFEND
      !DO !coeff !IN (!coeffs)
         /!CONCAT(!coeff,'_est')=SUM(!coeff)
      !DOEND
      .
   !DO !coeff !IN (!coeffs)
      COMPUTE !CONCAT(!coeff,'_est') = (!CONCAT(!coeff,'_est') / !nmi).
   !DOEND
   EXECUTE.
   * Berechne quadrierte Abweichung der einzelnen MI-Ergebnisse.
   !DO !coeff !IN (!coeffs)
      COMPUTE !CONCAT(!coeff,'_varmi') = ((!coeff - !CONCAT(!coeff,'_est')) ** 2).
   !DOEND
   EXECUTE.
   DATASET DECLARE mcr_bifie_results.
   * Aggregiere (Summenbildung der quadrierten Abweichungen und uebertragung des Schaetzers und der Replikationsvarianz (if any)).
   AGGREGATE
      /OUTFILE=mcr_bifie_results
      !IF (!breakvars~=!NULL) !THEN
         /PRESORTED
         /BREAK=!breakvars
      !IFEND
      !DO !coeff !IN (!coeffs)
         /!coeff=FIRST(!CONCAT(!coeff,'_est'))
         /!CONCAT(!coeff,'_varmi')=SUM(!CONCAT(!coeff,'_varmi'))
         /!CONCAT(!coeff,'_varrep')=MEAN(!CONCAT(!coeff,'_varrep'))    
      !DOEND
         /nmi_cnt=N.
      .
   DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
   * Ergaenze fehlende MI-Varianz, wenn 0-Werte (bei Zaehlungen) fehlen.
   !DO !coeff !IN (!coeffs)
      DO IF (nmi_cnt<!nmi).
         COMPUTE !CONCAT(!coeff,'_varmi') = (!CONCAT(!coeff,'_varmi') + (!coeff ** 2 * (!nmi - nmi_cnt))).
      END IF.
   !DOEND
   EXECUTE.
   * Berechne Varianz durch Division der M-1 Imputationen.
   !DO !coeff !IN (!coeffs)
      COMPUTE !CONCAT(!coeff,'_varmi') = (!CONCAT(!coeff,'_varmi') / (!nmi - 1)).
   !DOEND
   EXECUTE.
!ELSE
   *Wenn es keine Imputation gibt, dann kopiere einfach und erstelle leere VarMI-Variable.
   DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
   DATASET COPY mcr_bifie_results.
   DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
   !DO !coeff !IN (!coeffs)
      COMPUTE !CONCAT(!coeff,'_varmi') = $SYSMIS.
      EXECUTE.
   !DOEND
!IFEND

!ENDDEFINE.

DEFINE !mcr_bifie_calcse (nmi = !charend("/")/
                           nrep = !charend("/")/
                           coeffs = !charend("/")).

DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
!DO !coeff !IN (!coeffs)
   !LET !sevar = !CONCAT(!coeff,"_se")
   !LET !varmivar = !CONCAT(!coeff,"_varmi")
   !LET !varrepvar = !CONCAT(!coeff,"_varrep")
   !LET !dfvar = !CONCAT(!coeff,"_df")
   !LET !lowervar = !CONCAT(!coeff,"_lower")
   !LET !uppervar = !CONCAT(!coeff,"_upper")
   !LET !pvar = !CONCAT(!coeff,"_p")
   !LET !fracmissvar = !CONCAT(!coeff,"_fracmiss")
   COMPUTE !sevar = $SYSMIS.
   COMPUTE !dfvar = $SYSMIS.
   COMPUTE !lowervar = $SYSMIS.
   COMPUTE !uppervar = $SYSMIS.
   COMPUTE !pvar = $SYSMIS.
   COMPUTE !fracmissvar = $SYSMIS.
   !IF (!nmi>1) !THEN
      !IF (!nrep>1) !THEN
         COMPUTE !sevar = SQRT((1 + 1 / !nmi) * !varmivar + !varrepvar).
         DO IF !varmivar>10**-15.
            COMPUTE !dfvar = (!nmi - 1) * ((1 + (!nmi * !varrepvar / ((!nmi + 1) * !varmivar))) ** 2).
            COMPUTE !lowervar = !coeff + IDF.T(0.025,!dfvar) * !sevar.
            COMPUTE !uppervar = !coeff + IDF.T(0.975,!dfvar) * !sevar.
            COMPUTE !pvar = CDF.T(!coeff/!sevar,!dfvar).
            IF (!pvar > 0.5) !pvar= 1 - !pvar.
         ELSE.
            COMPUTE !lowervar = !coeff + IDF.NORMAL(0.025,0,1) * !sevar.
            COMPUTE !uppervar = !coeff + IDF.NORMAL(0.975,0,1) * !sevar.
            COMPUTE !pvar = CDF.NORMAL(!coeff/!sevar,0,1).
            IF (!pvar > 0.5) !pvar= 1 - !pvar.            
         END IF.
         !LET !rtmp = !CONCAT(!coeff,"_r_tmp")
         COMPUTE !rtmp = ((!nmi + 1) * !varmivar) / (!nmi * !varrepvar).
         COMPUTE !fracmissvar = (!rtmp + 2 / (!dfvar + 3)) / (!rtmp + 1).
      !ELSE
         COMPUTE !sevar = SQRT((1 + 1 / !nmi) * !varmivar).
         COMPUTE !lowervar = !coeff + IDF.NORMAL(0.025,0,1) * !sevar.
         COMPUTE !uppervar = !coeff + IDF.NORMAL(0.975,0,1) * !sevar.
         COMPUTE !pvar = CDF.NORMAL(!coeff/!sevar,0,1).
         IF (!pvar > 0.5) !pvar= 1 - !pvar.            
      !IFEND
   !ELSE
      !IF (!nrep>1) !THEN
         COMPUTE !sevar = SQRT(!varrepvar).
         COMPUTE !lowervar = !coeff + IDF.NORMAL(0.025,0,1) * !sevar.
         COMPUTE !uppervar = !coeff + IDF.NORMAL(0.975,0,1) * !sevar.
         COMPUTE !pvar = CDF.NORMAL(!coeff/!sevar,0,1).
         IF (!pvar > 0.5) !pvar= 1 - !pvar.     
      !IFEND
   !IFEND
   EXECUTE.
!DOEND

!ENDDEFINE.

DEFINE !mcr_bifie_countn (wgt=!charend('/')/
                                        nmi=!charend('/')/
                                        vars=!charend('/')/
                                        grp=!charend('/')/
                                        miss=!default('list') !charend('/')).

DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
!IF (!grp~=!NULL) !THEN
   SORT CASES BY !grp.
!IFEND

!IF (!miss='list') !THEN
   COMPUTE mcr_bifie_isvalidcase = (
      !LET !cnt = ' '
      !DO !var !IN (!vars)
         !IF (!LENGTH(!cnt)>1) !THEN AND !IFEND NOT MISSING(!var) 
         !LET !cnt = !CONCAT(!cnt,' ')
      !DOEND
      ).
   EXECUTE.
   WEIGHT BY !wgt.
   AGGREGATE
      /OUTFILE=* MODE=ADDVARIABLES
      !IF (!grp~=!NULL) !THEN /PRESORTED /BREAK=!grp !IFEND
      /mcr_bifie_n=N
      /mcr_bifie_nvalid=SUM(mcr_bifie_isvalidcase)
      /mcr_bifie_nu=NU.
   WEIGHT OFF.
   DATASET DECLARE mcr_bifie_countn.
   AGGREGATE
      /OUTFILE=mcr_bifie_countn
      !IF (!grp~=!NULL) !THEN /PRESORTED /BREAK=!grp !IFEND
      /n=FIRST(mcr_bifie_n)
      /nvalid=FIRST(mcr_bifie_nvalid)
      /nu=FIRST(mcr_bifie_nu)
      /nuvalid=SUM(mcr_bifie_isvalidcase).
    !IF (!nmi>1) !THEN
        DATASET ACTIVATE mcr_bifie_countn.
        COMPUTE n = n / !nmi.
        COMPUTE nvalid = nvalid / !nmi.
        COMPUTE nu = nu / !nmi.
        COMPUTE nuvalid = nuvalid / !nmi.
        EXECUTE.
    !IFEND
!ELSE
   !DO !var !IN (!vars)
      COMPUTE !CONCAT('mcr_bifie_isvalidcase_',!var) = (NOT MISSING(!var)).
   !DOEND
   EXECUTE.
   WEIGHT BY !wgt.
   AGGREGATE
      /OUTFILE=* MODE=ADDVARIABLES
      !IF (!grp~=!NULL) !THEN /PRESORTED /BREAK=!grp !IFEND
      /mcr_bifie_n=N
      /mcr_bifie_nu=NU
      !DO !var !IN (!vars)
         /!CONCAT('mcr_bifie_',!var,'_nvalid')=SUM(!CONCAT('mcr_bifie_isvalidcase_',!var))
      !DOEND
      .
   WEIGHT OFF.
   DATASET DECLARE mcr_bifie_countn.
   AGGREGATE
      /OUTFILE=mcr_bifie_countn
      !IF (!grp~=!NULL) !THEN /PRESORTED /BREAK=!grp !IFEND
      /n=FIRST(mcr_bifie_n)
      /nu=FIRST(mcr_bifie_nu)
      !DO !var !IN (!vars)
         /!CONCAT(!var,'_nvalid')=FIRST(!CONCAT('mcr_bifie_',!var,'_nvalid'))
         /!CONCAT(!var,'_nuvalid')=SUM(!CONCAT('mcr_bifie_isvalidcase_',!var))
      !DOEND
      .
    !IF (!nmi>1) !THEN
        DATASET ACTIVATE mcr_bifie_countn.
        COMPUTE n = n / !nmi.
        COMPUTE nu = nu / !nmi.
        !DO !var !IN (!vars)
            COMPUTE !CONCAT(!var,'_nvalid') = !CONCAT(!var,'_nvalid') / !nmi.
            COMPUTE !CONCAT(!var,'_nuvalid') = !CONCAT(!var,'_nuvalid') / !nmi.
        !DOEND
        EXECUTE.
    !IFEND
!IFEND

DATASET ACTIVATE mcr_bifie_results.
!IF (!grp~=!NULL) !THEN
   SORT CASES BY !grp.
!IFEND
MATCH FILES FILE=* / FILE=mcr_bifie_countn !IF (!grp~=!NULL) !THEN /BY !grp !IFEND.
DATASET CLOSE mcr_bifie_countn.

!ENDDEFINE.

DEFINE !mcr_bifie_close (debug = !default('no') !charend('/')).

!IF (!debug~='yes') !THEN
   DATASET ACTIVATE mcr_bifie_prev WINDOW=ASIS.
   DATASET CLOSE mcr_bifie_results.
   DATASET CLOSE mcr_bifie_estimates.
   DATASET CLOSE mcr_bifie_data.
   OMSEND TAG = 'NoCaseProcessing'.
   OMSEND TAG = 'KeepQuiet'.
!IFEND

RESTORE.

!ENDDEFINE.

DEFINE !DEPLOY (path = !charend("/")/
                            outpath = !charend("/")/
                            file1 = !charend("/")/
                            file2 = !charend("/")/
                            outfile = !charend("/")/
                            nmi = !charend("/")/
                            syntax = !charend("/")/
                            debug = !default("no") !charend("/")).

PRESERVE.
!IF (!debug="yes") !THEN
   SET PRINTBACK=ON.
   SET MPRINT=ON.
!IFEND
DATASET NAME mcr_bifie_prev.

!DO !cnt = 1 !TO !nmi
   *Bereite Dateinamen vor.
   !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!file1,'$')), 2))
   !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!file1,'$')), !BLANKS(1)))
   !LET !filename1 = !CONCAT(!SUBSTR(!file1,1,!beforeSign),!cnt,!SUBSTR(!file1,!afterSign))
   !IF (!INDEX(!filename1,".sav")=0) !THEN !LET !filename1 = !CONCAT(!filename1,".sav") !IFEND
   !LET !savefilename = !filename1.
   !IF (!outfile~=!NULL) !THEN
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!outfile,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!outfile,'$')), !BLANKS(1)))
      !LET !savefilename = !CONCAT(!SUBSTR(!outfile,1,!beforeSign),!cnt,!SUBSTR(!outfile,!afterSign))
      !IF (!INDEX(!savefilename,".sav")=0) !THEN !LET !savefilename = !CONCAT(!savefilename,".sav") !IFEND
   !IFEND
   !IF (!file2~=!NULL) !THEN
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!file2,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!file2,'$')), !BLANKS(1)))
      !LET !filename2 = !CONCAT(!SUBSTR(!file2,1,!beforeSign),!cnt,!SUBSTR(!file2,!afterSign))
      !IF (!INDEX(!filename2,".sav")=0) !THEN !LET !filename2 = !CONCAT(!filename2,".sav") !IFEND
   !IFEND

   *Hole Datei(en).
   !IF (!path~=!NULL) !THEN
      CD !QUOTE(!path). 
   !IFEND
   !IF (!file2~=!NULL) !THEN
      GET FILE=!QUOTE(!filename2).
      DATASET NAME deploy_file2.
   !IFEND
   GET FILE=!QUOTE(!filename1).
   DATASET NAME deploy_file1.
   
   *Fuehre Syntax aus.
   DATASET ACTIVATE deploy_file1 WINDOW=ASIS.
   !LET !syntaxname = !syntax
   !IF (!INDEX(!syntaxname,".sps")=0) !THEN !LET !syntaxname = !CONCAT(!syntaxname,".sps") !IFEND
   INSERT FILE=!QUOTE(!syntaxname).

   *Speichere (erste) Datei und schliesse.
   !IF (!outpath~=!NULL) !THEN
      CD !QUOTE(!outpath). 
   !IFEND
   SAVE OUTFILE=!QUOTE(!savefilename) /COMPRESSED.
   DATASET CLOSE deploy_file1.
   !IF (!file2~=!NULL) !THEN 
      DATASET CLOSE deploy_file2. 
   !IFEND
!DOEND

DATASET ACTIVATE mcr_bifie_prev.
!IF (!debug="yes") !THEN
   SET MPRINT=OFF.
   SET PRINTBACK=OFF.
!IFEND
RESTORE.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Univariate deskriptive Statistik (Mittelwerte und Standardabweichung).
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_univar (dataset=!charend('/')/
                                 vars=!charend('/')/
                                 stats=!charend('/')/
                                 wgt=!charend('/')/
                                 grp=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!default('') !charend('/')/
                                 presorted = !default('no') !charend('/')).

!LET !breakvars = !NULL
!IF (!nmi>1) !THEN !LET !breakvars = 'mcr_bifie_micnt' !IFEND
!IF (!grp ~= !NULL) !THEN !LET !breakvars = !CONCAT(!breakvars,' ',!grp) !IFEND

DATASET ACTIVATE !dataset WINDOW=ASIS.
WEIGHT BY !wgt.
!IF (!breakvars ~= !NULL !AND !presorted~='yes') !THEN
   SORT CASES BY !breakvars.
!IFEND
AGGREGATE
   /OUTFILE=!outfile
   !IF (!breakvars ~= !NULL) !THEN
      /PRESORTED
      /BREAK=!breakvars
   !IFEND
   !DO !var !IN (!vars)
      !DO !stat !IN (!stats)
         !CONCAT("/",!var,"_",!stat,!outsuffix,"=",!stat,"(",!var,")")
      !DOEND
   !DOEND
   .

!ENDDEFINE.

DEFINE !UNIVARcomplex (method = !charend("/")/
                           fay = !charend("/")/
                           wgt = !charend("/")/
                           rwgtbase = !charend("/")/
                           nrep = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           vars = !charend("/")/
                           grp = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           allinone = !default("no") !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")).

!mcr_bifie_openfile
   path=!path/
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   debug=!debug/.


!LET !plaingrp = !NULL
!IF (!allinone~='yes' !OR !INDEX(!grp,'$')=0) !THEN
      !LET !plaingrp = !grp
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!grp,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!grp,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!grp)) !THEN
         !LET !plaingrp = !SUBSTR(!grp,1,!beforeSign)
      !ELSE
         !LET !plaingrp = !CONCAT(!SUBSTR(!grp,1,!beforeSign),!SUBSTR(!grp,!afterSign))
      !IFEND
!IFEND
!LET !plainvars = !NULL
!DO !var !IN (!vars)
   !IF (!allinone~='yes' !OR !INDEX(!var,'$')=0) !THEN
      !LET !plainvars = !CONCAT(!plainvars,' ',!var)
   !ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!var,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!var,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!var)) !THEN
         !LET !oneplain = !SUBSTR(!var,1,!beforeSign)
      !ELSE
         !LET !oneplain = !CONCAT(!SUBSTR(!var,1,!beforeSign),!SUBSTR(!var,!afterSign))
      !IFEND
      !LET !plainvars = !CONCAT(!plainvars,' ',!oneplain)
   !IFEND
!DOEND

!mcr_bifie_addmifiles
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   vars=!vars !grp/.

!LET !stats = "MEAN SD"
DATASET DECLARE mcr_bifie_estimates.

* Berechne finale Schaetzer.
!mcr_bifie_univar
   dataset=mcr_bifie_data/
   vars=!plainvars/
   stats=!stats/
   grp=!plaingrp/
   wgt=!wgt/
   nmi=!nmi/
   outfile=mcr_bifie_estimates/.

* Rechne mit den Replicate Weights (if any).
!IF (!nrep>1) !THEN
   !LET !repdataset = 'mcr_bifie_data'.
   * Falls im Quick-Modus: Nimm nur ersten MI-Datensatz.
   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      DATASET COPY mcr_bifie_data_justone.
      DATASET ACTIVATE mcr_bifie_data_justone WINDOW=ASIS.
      SELECT IF (mcr_bifie_micnt=1).
      EXECUTE.
      !LET !repdataset = 'mcr_bifie_data_justone'.
   !IFEND
   
   !LET !matchby = !NULL
   !IF (!quick~='yes' !AND !nmi>1) !THEN !LET !matchby = 'mcr_bifie_micnt' !IFEND
   !IF (!plaingrp ~= !NULL) !THEN !LET !matchby = !CONCAT(!matchby,' ',!plaingrp) !IFEND
   !DO !cnt = 1 !TO !nrep
      DATASET DECLARE mcr_bifie_newestimates.
      !mcr_bifie_univar
         dataset=!repdataset/
         vars=!plainvars/
         stats=!stats/
         grp=!plaingrp/
         wgt=!CONCAT(!rwgtbase,!cnt)/
         nmi=!IF (!quick~='yes') !THEN !nmi !ELSE 0 !IFEND/
         outfile=mcr_bifie_newestimates/
         outsuffix=!CONCAT('_rep',!cnt)/
         presorted=!IF (!cnt>1) !THEN yes !ELSE no !IFEND/.
      DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
      !IF (!cnt=1 !AND !matchby~=!NULL) !THEN
         SORT CASES BY !matchby.
      !IFEND
      MATCH FILES FILE=* /FILE=mcr_bifie_newestimates !IF (!matchby~= !NULL) !THEN /BY !matchby !IFEND.
      DATASET CLOSE mcr_bifie_newestimates.
   !DOEND

   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET CLOSE mcr_bifie_data_justone.
   !IFEND
!IFEND

!LET !coeffs = !NULL
!DO !var !IN (!plainvars)
   !DO !stat !IN (!stats)
      !LET !coeffs = !CONCAT(!coeffs,' ',!var,'_',!stat)
   !DOEND
!DOEND

* Berechne Sampling Variance (if any).
!mcr_bifie_calcsampvar
   nrep = !nrep/
   method = !method/
   fay = !fay/
   coeffs = !coeffs/.

* Berechne MI-Variance (if any) und uebertrage.
!mcr_bifie_calcmivar
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/
   breakvars = !plaingrp.

* Addiere die Varianzquellen und ziehe die Wurzel fuer den Standardfehler.
!mcr_bifie_calcse
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Ergaenze Information zu Fallzahlen.
!mcr_bifie_countn
   wgt=!wgt/
   nmi=!nmi/
   vars=!plainvars/
   grp=!plaingrp/
   miss=pair/.

* Output.
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
FORMATS nu (F20.1).
SUMMARIZE
   /TABLES=
      !DO !gr !IN (!plaingrp)
         !gr
      !DOEND
      n
      nu
   /TITLE='Weighted and unweighted case count (per group)'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
!DO !var !IN (!plainvars)
   !DO !stat !IN (!stats)
      STRING !CONCAT(!var,'_',!stat,'_name') (A255).
      COMPUTE !CONCAT(!var,'_',!stat,'_name') = !QUOTE(!CONCAT(!var,' (',!stat,')')).
   !DOEND
!DOEND
EXECUTE.
VARSTOCASES
   /MAKE nvalid FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_nvalid') !DOEND
   /MAKE nuvalid FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_nuvalid') !DOEND
   !DO !stat !IN (!stats)
      /MAKE !CONCAT(!stat,'_name') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_name') !DOEND
      /MAKE !CONCAT(!stat,'_estimate') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat) !DOEND
      /MAKE !CONCAT(!stat,'_varmi') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_varmi') !DOEND
      /MAKE !CONCAT(!stat,'_varrep') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_varrep') !DOEND
      /MAKE !CONCAT(!stat,'_se') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_se') !DOEND
      /MAKE !CONCAT(!stat,'_df') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_df') !DOEND
      /MAKE !CONCAT(!stat,'_lower') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_lower') !DOEND
      /MAKE !CONCAT(!stat,'_upper') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_upper') !DOEND
      /MAKE !CONCAT(!stat,'_p_one') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_p') !DOEND
      /MAKE !CONCAT(!stat,'_fracmiss') FROM !DO !var !IN (!plainvars) !CONCAT(!var,'_',!stat,'_fracmiss') !DOEND
   !DOEND
   .
FORMATS nuvalid (F20.1).
!DO !stat !IN (!stats)
   FORMATS !CONCAT(!stat,'_estimate') (F20.4).
   FORMATS !CONCAT(!stat,'_varmi') (F20.6).
   FORMATS !CONCAT(!stat,'_varrep') (F20.6).
   FORMATS !CONCAT(!stat,'_se') (F20.6).
   FORMATS !CONCAT(!stat,'_df') (F20.2).
   FORMATS !CONCAT(!stat,'_lower') (F20.4).
   FORMATS !CONCAT(!stat,'_upper') (F20.4).
   FORMATS !CONCAT(!stat,'_p_one') (F20.4).
   FORMATS !CONCAT(!stat,'_fracmiss') (F20.2).
!DOEND
SUMMARIZE
   /TABLES=
      nvalid
      nuvalid
      !DO !stat !IN (!stats)
         !CONCAT(!stat,'_name')
         !CONCAT(!stat,'_estimate')
         !IF (!showvariances='yes') !THEN
            !CONCAT(!stat,'_varmi')
            !CONCAT(!stat,'_varrep')
         !IFEND
         !CONCAT(!stat,'_se')
         !CONCAT(!stat,'_df')
         !CONCAT(!stat,'_lower')
         !CONCAT(!stat,'_upper')
        !CONCAT(!stat,'_p_one')
         !CONCAT(!stat,'_fracmiss')
      !DOEND
      !IF (!plaingrp~=!NULL) !THEN
         !DO !onegrp !IN (!plaingrp)
            BY !onegrp
         !DOEND
      !IFEND
   /TITLE='Estimates and standard errors (per group)'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .

* Raeume zusammen.
!mcr_bifie_close
   debug=!debug/.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Korrelationen.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_correl (dataset=!charend('/')/
                                 vars=!charend('/')/
                                 w=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!charend('/')).

!IF (!nmi=!NULL !OR !nmi=0) !THEN
   !LET !repeat=1
!ELSE
   !LET !repeat=!nmi
!IFEND

!LET !varscopy = !vars.
!LET !varnames = !NULL
!DO !var !IN (!vars)
   !LET !varscopy = !TAIL(!varscopy)
   !IF (!varscopy~=!NULL) !THEN
      !DO !var2 !IN (!varscopy)
         !LET !varnames = !CONCAT(!varnames,' r',!var,'_',!var2)
      !DOEND
   !IFEND
!DOEND

DATASET ACTIVATE !dataset WINDOW=ASIS.
COMPUTE isvalid = (NOT MISSING(!w)
   !DO !var !IN (!vars)
      AND NOT MISSING(!var) 
   !DOEND
   ).
EXECUTE.
FILTER BY isvalid.
!IF (!nmi>1) !THEN
   SORT CASES BY mcr_bifie_micnt.
!IFEND

MATRIX.
GET ALLX /FILE=* /VARIABLES=!vars.
GET ALLW /FILE=* /VARIABLES=!w.
!IF (!nmi>1) !THEN
   GET MICNT /FILE=* /VARIABLES=mcr_bifie_micnt.
!IFEND
*Prepare matrix for save.
COMPUTE estims = MAKE(NCOL(ALLX)*(NCOL(ALLX)-1)/2+1,!repeat,0).

COMPUTE ARRIDX = 1.

!DO !cnt = 1 !TO !repeat
*take only one MI-dataset.
!IF (!nmi>1) !THEN
   COMPUTE CHOOSE = CSUM(MICNT = !cnt).
   COMPUTE W = ALLW(ARRIDX:(ARRIDX+CHOOSE-1)).
   COMPUTE X = ALLX(ARRIDX:(ARRIDX+CHOOSE-1),:).
   COMPUTE ARRIDX = ARRIDX+CHOOSE.
!ELSE
   COMPUTE W = ALLW.
   COMPUTE X = ALLX.
!IFEND
RELEASE(ALLX).
RELEASE(ALLW).
*Prepare the weights.
COMPUTE Ws = W.
LOOP i = 2 TO NCOL(X).
   COMPUTE Ws = {Ws, W}.
END LOOP.
*Calculate correlations.
COMPUTE J=MAKE(NROW(W),1,1).
COMPUTE JT=MAKE(1,NROW(W),1).
COMPUTE D = Ws &* X.
COMPUTE D = JT*D.
COMPUTE D = J*D.
COMPUTE D = D &* (1/(CSUM(W)))).
COMPUTE D = X - D.
COMPUTE COVAR = (TRANSPOS(D)*(Ws&*D)) &* (1/(CSUM(W)-1)).
COMPUTE STDDEV=SQRT(DIAG(COVAR)).
COMPUTE Droot=MDIAG(STDDEV).
COMPUTE invDroot=INV(Droot).
COMPUTE R=invDroot*COVAR*invDroot.
*Store the estimates.
COMPUTE estims(1,!cnt) = !cnt.
LOOP i = 1 TO (NROW(R)-1).
   LOOP h = i + 1 TO NCOL(R).
      *Das versteh ich bereits morgen nicht mehr, aber es funktioniert.
      COMPUTE estims((i-1)*NCOL(R)+h-(i+1)*i/2+1,!cnt) = R(i,h).
   END LOOP.
END LOOP.
*Raeume auf.
RELEASE W.
RELEASE X.
RELEASE J.
RELEASE JT.
RELEASE Ws.
RELEASE D.
RELEASE COVAR.
RELEASE STDDEV.
RELEASE Droot.
RELEASE invDroot.
RELEASE R.
GET ALLX /FILE=* /VARIABLES=!vars.
GET ALLW /FILE=* /VARIABLES=!w.
!DOEND

*Save the estimates.
SAVE TRANSPOS(estims) /OUTFILE=* /VARIABLES=mcr_bifie_micnt !varnames.
END MATRIX.

DATASET NAME !outfile.
!IF (!outsuffix~=!NULL) !THEN
   !DO !varname !IN (!varnames)
      RENAME VARIABLES (!varname=!CONCAT(!varname,!outsuffix)).
   !DOEND
!IFEND

!ENDDEFINE.

DEFINE !CORRELcomplex (method = !charend("/")/
                           fay = !charend("/")/
                           wgt = !charend("/")/
                           rwgtbase = !charend("/")/
                           nrep = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           vars = !charend("/")/
                           sel = !charend("/")/
                           quick = !default("no") !charend("/")/
                           showvariances = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           allinone = !default("no") !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")).

!mcr_bifie_openfile
   path=!path/
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   debug=!debug/
   sel=!sel/.

!LET !plainvars = !NULL
!DO !var !IN (!vars)
   !IF (!allinone~='yes' !OR !INDEX(!var,'$')=0) !THEN
      !LET !plainvars = !CONCAT(!plainvars,' ',!var)
   !ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!var,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!var,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!var)) !THEN
         !LET !oneplain = !SUBSTR(!var,1,!beforeSign)
      !ELSE
         !LET !oneplain = !CONCAT(!SUBSTR(!var,1,!beforeSign),!SUBSTR(!var,!afterSign))
      !IFEND
      !LET !plainvars = !CONCAT(!plainvars,' ',!oneplain)
   !IFEND
!DOEND

!mcr_bifie_addmifiles
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   vars=!vars/
   sel=!sel/.

DATASET DECLARE mcr_bifie_estimates.

* Berechne finale Schaetzer.
!mcr_bifie_correl
   dataset=mcr_bifie_data/
   vars=!plainvars/
   w=!wgt/
   nmi=!nmi/
   outfile=mcr_bifie_estimates/.

* Rechne mit den Replicate Weights (if any).
!IF (!nrep>1) !THEN
   !LET !repdataset = 'mcr_bifie_data'.
   * Falls im Quick-Modus: Nimm nur ersten MI-Datensatz.
   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      DATASET COPY mcr_bifie_data_justone.
      DATASET ACTIVATE mcr_bifie_data_justone WINDOW=ASIS.
      SELECT IF (mcr_bifie_micnt=1).
      EXECUTE.
      !LET !repdataset = 'mcr_bifie_data_justone'.
   !IFEND
   
   !LET !matchby = !NULL
   !IF (!quick~='yes' !AND !nmi>1) !THEN !LET !matchby = 'mcr_bifie_micnt' !IFEND
   !DO !cnt = 1 !TO !nrep
      DATASET DECLARE mcr_bifie_newestimates.
      !mcr_bifie_correl
         dataset=!repdataset/
         vars=!plainvars/
         w=!CONCAT(!rwgtbase,!cnt)/
         nmi=!IF (!quick~='yes') !THEN !nmi !ELSE 0 !IFEND/
         outfile=mcr_bifie_newestimates/
         outsuffix=!CONCAT('_rep',!cnt)/.
      DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
      !IF (!cnt=1 !AND !matchby~=!NULL) !THEN
         SORT CASES BY !matchby.
      !IFEND
      MATCH FILES FILE=* /FILE=mcr_bifie_newestimates !IF (!matchby~= !NULL) !THEN /BY !matchby !IFEND.
      DATASET CLOSE mcr_bifie_newestimates.
   !DOEND

   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET CLOSE mcr_bifie_data_justone.
   !IFEND
!IFEND

!LET !varscopy = !plainvars.
!LET !coeffs = !NULL
!DO !var !IN (!plainvars)
   !LET !varscopy = !TAIL(!varscopy)
   !IF (!varscopy~=!NULL) !THEN
      !DO !var2 !IN (!varscopy)
         !LET !coeffs = !CONCAT(!coeffs,' r',!var,'_',!var2)
      !DOEND
   !IFEND
!DOEND

* Berechne Sampling Variance (if any).
!mcr_bifie_calcsampvar
   nrep = !nrep/
   method = !method/
   fay = !fay/
   coeffs = !coeffs/.

* Berechne MI-Variance (if any) und uebertrage.
!mcr_bifie_calcmivar
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Addiere die Varianzquellen und ziehe die Wurzel fuer den Standardfehler.
!mcr_bifie_calcse
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Ergaenze Information zu Fallzahlen.
!mcr_bifie_countn
   wgt=!wgt/
   nmi=!nmi/
   vars=!plainvars/.

* Output.
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
FORMATS nu nuvalid (F20.1).
SUMMARIZE
   /TABLES=
      n
      nu
      nvalid
      nuvalid
   /TITLE='Weighted and unweighted case count'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
!DO !coeff !IN (!coeffs)
   STRING !CONCAT(!coeff,'_name') (A255).
   COMPUTE !CONCAT(!coeff,'_name') = !QUOTE(!coeff).
!DOEND
EXECUTE.
VARSTOCASES
   /MAKE name FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_name') !DOEND
   /MAKE estimate FROM !DO !coeff !IN (!coeffs) !coeff !DOEND
   /MAKE varmi FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_varmi') !DOEND
   /MAKE varrep FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_varrep') !DOEND
   /MAKE se FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_se') !DOEND
   /MAKE df FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_df') !DOEND
   /MAKE lower FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_lower') !DOEND
   /MAKE upper FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_upper') !DOEND
   /MAKE p_one FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_p') !DOEND
   /MAKE fracmiss FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_fracmiss') !DOEND
   .
FORMATS df fracmiss (F20.2).
FORMATS estimate lower upper p_one (F20.4).
FORMATS varmi varrep se (F20.6).
SUMMARIZE
   /TABLES=name estimate !IF (!showvariances='yes') !THEN varmi varrep !IFEND se df lower upper p_one fracmiss
   /TITLE='Correlations (listwise)'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .

* Raeume zusammen.
!mcr_bifie_close
   debug=!debug/.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Multiple lineare Regression.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_linreg (dataset=!charend('/')/
                                 y=!charend('/')/
                                 x=!charend('/')/
                                 w=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!charend('/')/
                                 stdcoeff=!default('yes') !charend('/')/
                                 presorted=!default('no') !charend('/')).

!IF (!nmi=!NULL !OR !nmi=0) !THEN
   !LET !repeat=1
!ELSE
   !LET !repeat=!nmi
!IFEND

DATASET ACTIVATE !dataset WINDOW=ASIS.
COMPUTE isvalid = (NOT MISSING(!w) AND NOT MISSING(!y)
   !DO !xvar !IN (!x)
      AND NOT MISSING(!xvar) 
   !DOEND
   ).
EXECUTE.
FILTER BY isvalid.
!IF (!nmi>1 !AND !presorted~='yes') !THEN
   SORT CASES BY mcr_bifie_micnt.
!IFEND

MATRIX.
GET ALLY /FILE=* /VARIABLES=!y.
GET ALLX1 /FILE=* /VARIABLES=!x.
GET ALLW /FILE=* /VARIABLES=!w.
!IF (!nmi>1) !THEN
   GET MICNT /FILE=* /VARIABLES=mcr_bifie_micnt.
!IFEND

*Prepare storage for estimates.
!IF (!stdcoeff~='no') !THEN
   COMPUTE estims = MAKE(NCOL(ALLX1)*2+3,!repeat,0).
!ELSE
   COMPUTE estims = MAKE(NCOL(ALLX1)+3,!repeat,0).
!IFEND

COMPUTE ARRIDX = 1.

!DO !cnt = 1 !TO !repeat
*take only one MI-dataset.
!IF (!nmi>1) !THEN
   COMPUTE CHOOSE = CSUM(MICNT = !cnt).
   COMPUTE W = ALLW(ARRIDX:(ARRIDX+CHOOSE-1)).
   COMPUTE X1 = ALLX1(ARRIDX:(ARRIDX+CHOOSE-1),:).
   COMPUTE Y = ALLY(ARRIDX:(ARRIDX+CHOOSE-1)).
   COMPUTE ARRIDX = ARRIDX+CHOOSE.
!ELSE
   COMPUTE W = ALLW.
   COMPUTE X1 = ALLX1.
   COMPUTE Y = ALLY.
!IFEND
COMPUTE J=MAKE(NROW(W),1,1).
COMPUTE JT=TRANSPOS(J).
COMPUTE X = { J, X1 }.
RELEASE ALLY.
RELEASE ALLX1.
RELEASE ALLW.
*Prepare the weights.
COMPUTE Ws = W.
!DO !xvar !IN (!x)
   COMPUTE Ws = {Ws, W}.
!DOEND
*Calculate the estimates.
COMPUTE WX = Ws&*X.
COMPUTE WY = W&*Y.
COMPUTE WSUM = CSUM(W).
COMPUTE XT=TRANSPOS(X).
COMPUTE XDX=XT*WX.
COMPUTE B=SOLVE(XDX,XT*WY).
COMPUTE BT=TRANSPOS(B).
COMPUTE YT=TRANSPOS(Y).
*Calculate R-square.
COMPUTE TOTALSS=YT*WY-(JT*WY)**2/WSUM.
COMPUTE MODELSS=BT*XT*WY-(JT*WY)**2/WSUM.
COMPUTE RSQ=MODELSS/TOTALSS.
*Calculate standardized estimates.
!IF (!stdcoeff~='no') !THEN
   COMPUTE YX = { Y, X1}.
   COMPUTE DYX = Ws&*YX.
   COMPUTE DYX = JT*DYX.
   COMPUTE DYX = J*DYX.
   COMPUTE DYX = DYX &* (1/WSUM).
   COMPUTE DYX = YX - DYX.
   COMPUTE WDYX = Ws&*DYX.
   COMPUTE VARs = DIAG((TRANSPOS(DYX)*WDYX)&*(1/(WSUM-1))).
   COMPUTE BETA = (B&*SQRT(VARs))&*(1/SQRT(VARs(1))).
   *Omit the beta for the constant.
   COMPUTE BETA = BETA(2:NROW(BETA)).
!IFEND
*Store the estimates.
!IF (!stdcoeff~='no') !THEN
   COMPUTE estims(:,!cnt) = {!cnt; B; BETA; RSQ}.
!ELSE
   COMPUTE estims(:,!cnt) = {!cnt; B; RSQ}.
!IFEND
*Raeume auf.
RELEASE W.
RELEASE X1.
RELEASE Y.
RELEASE Ws.
RELEASE WX.
RELEASE WY.
RELEASE XT.
RELEASE XDX.
RELEASE B.
RELEASE BT.
RELEASE YT.
RELEASE YX.
RELEASE DYX.
RELEASE WDYX.
GET ALLY /FILE=* /VARIABLES=!y.
GET ALLX1 /FILE=* /VARIABLES=!x.
GET ALLW /FILE=* /VARIABLES=!w.
!DOEND

*Save the estimates.
!LET !coeffs = 'b0'
!DO !xvar !IN (!x)
   !LET !coeffs = !CONCAT(!coeffs,' b',!xvar)
!DOEND
!IF (!stdcoeff~='no') !THEN
   !DO !xvar !IN (!x)
      !LET !coeffs = !CONCAT(!coeffs,' beta',!xvar)
   !DOEND
!IFEND
!LET !coeffs = !CONCAT(!coeffs,' rsq')
SAVE TRANSPOS(estims)  /OUTFILE=* /VARIABLES=mcr_bifie_micnt !coeffs.
END MATRIX.

DATASET NAME !outfile.
!IF (!outsuffix~=!NULL) !THEN
   !DO !coeff !IN (!coeffs)
      RENAME VARIABLES (!coeff=!CONCAT(!coeff,!outsuffix)).
   !DOEND
!IFEND

!ENDDEFINE.

DEFINE !LINREGcomplex (method = !charend("/")/
                           fay = !charend("/")/
                           wgt = !charend("/")/
                           rwgtbase = !charend("/")/
                           nrep = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           dep = !charend("/")/
                           pre = !charend("/")/
                           sel = !charend("/")/
                           quick = !default("no") !charend("/")/
                           stdcoeff = !default("yes") !charend("/")/
                           showvariances = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           allinone = !default("no") !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")).

!mcr_bifie_openfile
   path=!path/
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   debug=!debug/
   sel=!sel/.

!LET !plaindep = !NULL
!IF (!allinone~='yes' !OR !INDEX(!dep,'$')=0) !THEN
      !LET !plaindep = !dep
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!dep,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!dep,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!dep)) !THEN
         !LET !plaindep = !SUBSTR(!dep,1,!beforeSign)
      !ELSE
         !LET !plaindep = !CONCAT(!SUBSTR(!dep,1,!beforeSign),!SUBSTR(!dep,!afterSign))
      !IFEND
!IFEND
!LET !plainpre = !NULL
!DO !var !IN (!pre)
   !IF (!allinone~='yes' !OR !INDEX(!var,'$')=0) !THEN
      !LET !plainpre = !CONCAT(!plainpre,' ',!var)
   !ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!var,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!var,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!var)) !THEN
         !LET !oneplain = !SUBSTR(!var,1,!beforeSign)
      !ELSE
         !LET !oneplain = !CONCAT(!SUBSTR(!var,1,!beforeSign),!SUBSTR(!var,!afterSign))
      !IFEND
      !LET !plainpre = !CONCAT(!plainpre,' ',!oneplain)
   !IFEND
!DOEND

!mcr_bifie_addmifiles
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   vars=!dep !pre/
   sel=!sel/.

DATASET DECLARE mcr_bifie_estimates.

* Berechne finale Schaetzer.
!mcr_bifie_linreg
   dataset=mcr_bifie_data/
   y=!plaindep/
   x=!plainpre/
   w=!wgt/
   nmi=!nmi/
   outfile=mcr_bifie_estimates/
   stdcoeff=!stdcoeff/.

* Rechne mit den Replicate Weights (if any).
!IF (!nrep>1) !THEN
   !LET !repdataset = 'mcr_bifie_data'.
   * Falls im Quick-Modus: Nimm nur ersten MI-Datensatz.
   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      DATASET COPY mcr_bifie_data_justone.
      DATASET ACTIVATE mcr_bifie_data_justone WINDOW=ASIS.
      SELECT IF (mcr_bifie_micnt=1).
      EXECUTE.
      !LET !repdataset = 'mcr_bifie_data_justone'.
   !IFEND
   
   !LET !matchby = !NULL
   !IF (!quick~='yes' !AND !nmi>1) !THEN !LET !matchby = 'mcr_bifie_micnt' !IFEND
   !DO !cnt = 1 !TO !nrep
      DATASET DECLARE mcr_bifie_newestimates.
      !mcr_bifie_linreg
         dataset=!repdataset/
         y=!plaindep/
         x=!plainpre/
         w=!CONCAT(!rwgtbase,!cnt)/
         nmi=!IF (!quick~='yes') !THEN !nmi !ELSE 0 !IFEND/
         outfile=mcr_bifie_newestimates/
         outsuffix=!CONCAT('_rep',!cnt)/
         stdcoeff=!stdcoeff/
         presorted=yes/.
      DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
      !IF (!cnt=1 !AND !matchby~=!NULL) !THEN
         SORT CASES BY !matchby.
      !IFEND
      MATCH FILES FILE=* /FILE=mcr_bifie_newestimates !IF (!matchby~= !NULL) !THEN /BY !matchby !IFEND.
      DATASET CLOSE mcr_bifie_newestimates.
   !DOEND

   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET CLOSE mcr_bifie_data_justone.
   !IFEND
!IFEND

!LET !coeffs = 'b0'
!DO !xvar !IN (!plainpre)
   !LET !coeffs = !CONCAT(!coeffs,' b',!xvar)
!DOEND
!IF (!stdcoeff~='no') !THEN
   !DO !xvar !IN (!plainpre)
      !LET !coeffs = !CONCAT(!coeffs,' beta',!xvar)
   !DOEND
!IFEND
!LET !coeffs = !CONCAT(!coeffs,' rsq')

* Berechne Sampling Variance (if any).
!mcr_bifie_calcsampvar
   nrep = !nrep/
   method = !method/
   fay = !fay/
   coeffs = !coeffs/.

* Berechne MI-Variance (if any) und uebertrage.
!mcr_bifie_calcmivar
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Addiere die Varianzquellen und ziehe die Wurzel fuer den Standardfehler.
!mcr_bifie_calcse
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Ergaenze Information zu Fallzahlen.
!mcr_bifie_countn
   wgt=!wgt/
   nmi=!nmi/
   vars=!plaindep !plainpre/.

* Output.
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
FORMATS nu nuvalid (F20.1).
SUMMARIZE
   /TABLES=
      n
      nu
      nvalid
      nuvalid
   /TITLE='Weighted and unweighted case count'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
!DO !coeff !IN (!coeffs)
   STRING !CONCAT(!coeff,'_name') (A255).
   COMPUTE !CONCAT(!coeff,'_name') = !QUOTE(!coeff).
!DOEND
EXECUTE.
VARSTOCASES
   /MAKE name FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_name') !DOEND
   /MAKE estimate FROM !DO !coeff !IN (!coeffs) !coeff !DOEND
   /MAKE varmi FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_varmi') !DOEND
   /MAKE varrep FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_varrep') !DOEND
   /MAKE se FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_se') !DOEND
   /MAKE df FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_df') !DOEND
   /MAKE lower FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_lower') !DOEND
   /MAKE upper FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_upper') !DOEND
   /MAKE p_one FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_p') !DOEND
   /MAKE fracmiss FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_fracmiss') !DOEND
   . 
FORMATS df fracmiss (F20.2).
FORMATS estimate lower upper p_one (F20.4).
FORMATS varmi varrep se (F20.6).
SUMMARIZE
   /TABLES=name estimate !IF (!showvariances='yes') !THEN varmi varrep !IFEND se df lower upper p_one fracmiss
   /TITLE=!QUOTE(!CONCAT('Regression coefficients for dependent ',!dep))
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .

* Raeume zusammen.
!mcr_bifie_close
   debug=!debug/.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Kreuztabulierung.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_crosstab(dataset=!charend('/')/
                                 varrow=!charend('/')/
                                 varcol=!charend('/')/
                                 wgt=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!charend('/')).

DATASET ACTIVATE !dataset WINDOW=ASIS.
WEIGHT BY !wgt.
AGGREGATE
   /OUTFILE=!outfile
   /BREAK= !IF (!nmi>1) !THEN mcr_bifie_micnt !IFEND !varrow !varcol
   /cnt=N.
DATASET ACTIVATE !outfile WINDOW=ASIS.
AGGREGATE
   /OUTFILE=* MODE=ADDVARIABLES
   /PRESORTED
   /BREAK= !IF (!nmi>1) !THEN mcr_bifie_micnt !IFEND !varrow
   /rowsum=SUM(cnt).
COMPUTE rowpct = cnt / rowsum.
EXECUTE.
AGGREGATE
   /OUTFILE=* MODE=ADDVARIABLES
   /BREAK= !IF (!nmi>1) !THEN mcr_bifie_micnt !IFEND !varcol
   /colsum=SUM(cnt).
AGGREGATE
   /OUTFILE=* MODE=ADDVARIABLES
   !IF (!nmi>1) !THEN 
      /PRESORTED 
      /BREAK=mcr_bifie_micnt 
   !IFEND
   /totsum=SUM(cnt).
COMPUTE marg = colsum / totsum.
EXECUTE.
DELETE VARIABLES rowsum colsum totsum.
!IF (!outsuffix~=!NULL) !THEN
   RENAME VARIABLES (cnt=!CONCAT('cnt',!outsuffix)) (rowpct=!CONCAT('rowpct',!outsuffix)) (marg=!CONCAT('marg',!outsuffix)).
!IFEND
SORT CASES BY !IF (!nmi>1) !THEN mcr_bifie_micnt !IFEND !varrow !varcol.

!ENDDEFINE.

DEFINE !CROSSTABcomplex (method = !charend("/")/
                           fay = !charend("/")/
                           wgt = !charend("/")/
                           rwgtbase = !charend("/")/
                           nrep = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           varrow = !charend("/")/
                           varcol = !charend("/")/
                           sel = !charend("/")/
                           quick = !default("no") !charend("/")/
                           showvariances = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           allinone = !default("no") !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")).

!mcr_bifie_openfile
   path=!path/
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   debug=!debug/
   sel=!sel/.

!LET !plainvarrow = !NULL
!IF (!allinone~='yes' !OR !INDEX(!varrow,'$')=0) !THEN
      !LET !plainvarrow = !varrow
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!varrow,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!varrow,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!varrow)) !THEN
         !LET !plainvarrow = !SUBSTR(!varrow,1,!beforeSign)
      !ELSE
         !LET !plainvarrow = !CONCAT(!SUBSTR(!varrow,1,!beforeSign),!SUBSTR(!varrow,!afterSign))
      !IFEND
!IFEND
!LET !plainvarcol = !NULL
!IF (!allinone~='yes' !OR !INDEX(!varcol,'$')=0) !THEN
      !LET !plainvarcol = !varcol
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!varcol,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!varcol,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!varcol)) !THEN
         !LET !plainvarcol = !SUBSTR(!varcol,1,!beforeSign)
      !ELSE
         !LET !plainvarcol = !CONCAT(!SUBSTR(!varcol,1,!beforeSign),!SUBSTR(!varcol,!afterSign))
      !IFEND
!IFEND

!mcr_bifie_addmifiles
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   vars=!varrow !varcol/
   sel=!sel/.

DATASET DECLARE mcr_bifie_estimates.

* Berechne finale Schaetzer.
!mcr_bifie_crosstab
   dataset=mcr_bifie_data/
   varrow=!plainvarrow/
   varcol=!plainvarcol/
   wgt=!wgt/
   nmi=!nmi/
   outfile=mcr_bifie_estimates/.

* Rechne mit den Replicate Weights (if any).
!IF (!nrep>1) !THEN
   !LET !repdataset = 'mcr_bifie_data'.
   * Falls im Quick-Modus: Nimm nur ersten MI-Datensatz.
   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      DATASET COPY mcr_bifie_data_justone.
      DATASET ACTIVATE mcr_bifie_data_justone WINDOW=ASIS.
      SELECT IF (mcr_bifie_micnt=1).
      EXECUTE.
      !LET !repdataset = 'mcr_bifie_data_justone'.
   !IFEND
   
   !LET !matchby = !NULL
   !IF (!quick~='yes' !AND !nmi>1) !THEN !LET !matchby = 'mcr_bifie_micnt' !IFEND
   !DO !cnt = 1 !TO !nrep
      DATASET DECLARE mcr_bifie_newestimates.
      !mcr_bifie_crosstab
         dataset=!repdataset/
         varrow=!plainvarrow/
         varcol=!plainvarcol/
         wgt=!CONCAT(!rwgtbase,!cnt)/
         nmi=!IF (!quick~='yes') !THEN !nmi !ELSE 0 !IFEND/
         outfile=mcr_bifie_newestimates/
         outsuffix=!CONCAT('_rep',!cnt)/.
      DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
      !IF (!cnt=1 !AND !matchby~=!NULL) !THEN
         SORT CASES BY !matchby.
      !IFEND
      MATCH FILES FILE=* /FILE=mcr_bifie_newestimates !IF (!matchby~= !NULL) !THEN /BY !matchby !IFEND.
      DATASET CLOSE mcr_bifie_newestimates.
   !DOEND

   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET CLOSE mcr_bifie_data_justone.
   !IFEND
!IFEND

!LET !coeffs = 'cnt rowpct marg'

* Berechne Sampling Variance (if any).
!mcr_bifie_calcsampvar
   nrep = !nrep/
   method = !method/
   fay = !fay/
   coeffs = !coeffs/.

* Berechne MI-Variance (if any) und uebertrage.
!mcr_bifie_calcmivar
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/
   breakvars = !plainvarrow !plainvarcol/.

* Addiere die Varianzquellen und ziehe die Wurzel fuer den Standardfehler.
!mcr_bifie_calcse
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Ergaenze Information zu Fallzahlen.
!mcr_bifie_countn
   wgt=!wgt/
   nmi=!nmi/
   vars=!plainvarrow !plainvarcol/.

* Output.
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
FORMATS nu nuvalid (F20.1).
SUMMARIZE
   /TABLES=
      n
      nu
      nvalid
      nuvalid
   /TITLE='Weighted and unweighted case count'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
!DO !coeff !IN (!coeffs)
   STRING !CONCAT(!coeff,'_name') (A255).
   COMPUTE !CONCAT(!coeff,'_name') = !QUOTE(!coeff).
!DOEND
EXECUTE.
VARSTOCASES
   /MAKE name FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_name') !DOEND
   /MAKE estimate FROM !DO !coeff !IN (!coeffs) !coeff !DOEND
   /MAKE varmi FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_varmi') !DOEND
   /MAKE varrep FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_varrep') !DOEND
   /MAKE se FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_se') !DOEND
   /MAKE df FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_df') !DOEND
   /MAKE lower FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_lower') !DOEND
   /MAKE upper FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_upper') !DOEND
   /MAKE p_one FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_p') !DOEND
   /MAKE fracmiss FROM !DO !coeff !IN (!coeffs) !CONCAT(!coeff,'_fracmiss') !DOEND
   . 
FORMATS df fracmiss (F20.2).
FORMATS estimate lower upper p_one (F20.4).
FORMATS varmi varrep se (F20.6).
COMPUTE filter$ = (name='cnt').
FILTER BY filter$.
SUMMARIZE
   /TABLES=!plainvarrow !plainvarcol name estimate !IF (!showvariances='yes') !THEN varmi varrep !IFEND se df lower upper fracmiss
   /TITLE='Cell count'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
COMPUTE filter$ = (name='rowpct').
FILTER BY filter$.
SUMMARIZE
   /TABLES=!plainvarrow !plainvarcol name estimate !IF (!showvariances='yes') !THEN varmi varrep !IFEND se df lower upper fracmiss
   /TITLE='Row percentages'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
FILTER OFF.
DATASET DECLARE mcr_bifie_margresults.
AGGREGATE /OUTFILE=mcr_bifie_margresults /BREAK=!plainvarcol name /estimate=MEAN(estimate) /varmi=MEAN(varmi) /varrep=MEAN(varrep) /se=MEAN(se) /df=MEAN(df) /lower=MEAN(lower) /upper=MEAN(upper) /p_one=MEAN(p_one) /fracmiss=MEAN(fracmiss).
DATASET ACTIVATE mcr_bifie_margresults WINDOW=ASIS.
FORMATS df fracmiss (F20.2).
FORMATS estimate lower upper p_one (F20.4).
FORMATS varmi varrep se (F20.6).
COMPUTE filter$ = (name='marg').
FILTER BY filter$.
SUMMARIZE
   /TABLES=!plainvarcol name estimate !IF (!showvariances='yes') !THEN varmi varrep !IFEND se df lower upper fracmiss
   /TITLE='Marginal distribution'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
DATASET CLOSE mcr_bifie_margresults.

* Raeume zusammen.
!mcr_bifie_close
   debug=!debug/.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Einfache Haeufigkeiten.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_freq (dataset=!charend('/')/
                                 vars=!charend('/')/
                                 wgt=!charend('/')/
                                 grp=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!charend('/')).

!LET !breakvars = !NULL
!IF (!nmi>1) !THEN !LET !breakvars = 'mcr_bifie_micnt' !IFEND
!IF (!grp ~= !NULL) !THEN !LET !breakvars = !CONCAT(!breakvars,' ',!grp) !IFEND

DATASET ACTIVATE !dataset WINDOW=ASIS.
WEIGHT BY !wgt.
AGGREGATE
   /OUTFILE=* MODE=ADDVARIABLES
   !IF (!breakvars ~= !NULL) !THEN
      /BREAK=!breakvars
   !IFEND
   /mcr_bifie_n=N
   !DO !var !IN (!vars)
      !CONCAT('/mcr_bifie_',!var,'_valid')=N(!var)
   !DOEND
   .
!DO !var !IN (!vars)
   DATASET DECLARE mcr_bifie_freq_tmp.
   DATASET ACTIVATE !dataset WINDOW=ASIS.
   AGGREGATE
      /OUTFILE=mcr_bifie_freq_tmp
      /BREAK=!breakvars !var
      /cnt=N
      /pct=FIRST(mcr_bifie_n)
      /validpct=FIRST(!CONCAT('mcr_bifie_',!var,'_valid'))
      .
   DATASET ACTIVATE mcr_bifie_freq_tmp WINDOW=ASIS.
   STRING varname (A255).
   COMPUTE varname = !QUOTE(!var).
   EXECUTE.
   RENAME VARIABLES (!var=category).
   COMPUTE pct = cnt / pct.
   DO IF (NOT MISSING(category)).
      COMPUTE validpct = cnt / validpct.
   END IF.
   DO IF (MISSING(category)).
      COMPUTE validpct = $SYSMIS.
   END IF.
   EXECUTE.
   DATASET ACTIVATE !outfile WINDOW=ASIS.
   ADD FILES FILE=* / FILE=mcr_bifie_freq_tmp.
   DATASET CLOSE mcr_bifie_freq_tmp.
!DOEND

DATASET ACTIVATE !outfile WINDOW=ASIS.
VALUE LABELS category.
VARIABLE LABELS category ''.
!IF (!outsuffix~=!NULL) !THEN
   RENAME VARIABLES (cnt=!CONCAT('cnt',!outsuffix)).
   RENAME VARIABLES (pct=!CONCAT('pct',!outsuffix)).
   RENAME VARIABLES (validpct=!CONCAT('validpct',!outsuffix)).
!IFEND
SORT CASES BY varname !breakvars category.

DATASET ACTIVATE !dataset WINDOW=ASIS.
DELETE VARIABLES mcr_bifie_n !DO !var !IN (!vars) !CONCAT('mcr_bifie_',!var,'_valid') !DOEND.

!ENDDEFINE.

DEFINE !FREQcomplex (method = !charend("/")/
                           fay = !charend("/")/
                           wgt = !charend("/")/
                           rwgtbase = !charend("/")/
                           nrep = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           vars = !charend("/")/
                           grp = !charend("/")/
                           quick = !default("no") !charend("/")/
                           showvariances = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           allinone = !default("no") !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")).

!mcr_bifie_openfile
   path=!path/
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   debug=!debug/.

!LET !plaingrp = !NULL
!IF (!allinone~='yes' !OR !INDEX(!grp,'$')=0) !THEN
      !LET !plaingrp = !grp
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!grp,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!grp,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!grp)) !THEN
         !LET !plaingrp = !SUBSTR(!grp,1,!beforeSign)
      !ELSE
         !LET !plaingrp = !CONCAT(!SUBSTR(!grp,1,!beforeSign),!SUBSTR(!grp,!afterSign))
      !IFEND
!IFEND
!LET !plainvars = !NULL
!DO !var !IN (!vars)
   !IF (!allinone~='yes' !OR !INDEX(!var,'$')=0) !THEN
      !LET !plainvars = !CONCAT(!plainvars,' ',!var)
   !ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!var,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!var,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!var)) !THEN
         !LET !oneplain = !SUBSTR(!var,1,!beforeSign)
      !ELSE
         !LET !oneplain = !CONCAT(!SUBSTR(!var,1,!beforeSign),!SUBSTR(!var,!afterSign))
      !IFEND
      !LET !plainvars = !CONCAT(!plainvars,' ',!oneplain)
   !IFEND
!DOEND

!mcr_bifie_addmifiles
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   vars=!vars !grp/.

DATA LIST FREE /varname (A255).
BEGIN DATA.
END DATA.
DATASET NAME mcr_bifie_estimates.

* Berechne finale Schaetzer.
!mcr_bifie_freq
   dataset=mcr_bifie_data/
   vars=!plainvars/
   grp=!plaingrp/
   wgt=!wgt/
   nmi=!nmi/
   outfile=mcr_bifie_estimates/.

* Rechne mit den Replicate Weights (if any).
!IF (!nrep>1) !THEN
   !LET !repdataset = 'mcr_bifie_data'.
   * Falls im Quick-Modus: Nimm nur ersten MI-Datensatz.
   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      DATASET COPY mcr_bifie_data_justone.
      DATASET ACTIVATE mcr_bifie_data_justone WINDOW=ASIS.
      SELECT IF (mcr_bifie_micnt=1).
      EXECUTE.
      !LET !repdataset = 'mcr_bifie_data_justone'.
   !IFEND
   
   !LET !matchby = 'varname'
   !IF (!quick~='yes' !AND !nmi>1) !THEN !LET !matchby = !CONCAT(!matchby,' ','mcr_bifie_micnt') !IFEND
   !IF (!plaingrp ~= !NULL) !THEN !LET !matchby = !CONCAT(!matchby,' ',!plaingrp) !IFEND
   !LET !matchby = !CONCAT(!matchby,' ','category')
   !DO !cnt = 1 !TO !nrep
      DATA LIST FREE /varname (A255).
      BEGIN DATA.
      END DATA.
      DATASET NAME mcr_bifie_newestimates.
      !mcr_bifie_freq
         dataset=!repdataset/
         vars=!plainvars/
         grp=!plaingrp/
         wgt=!CONCAT(!rwgtbase,!cnt)/
         nmi=!IF (!quick~='yes') !THEN !nmi !ELSE 0 !IFEND/
         outfile=mcr_bifie_newestimates/
         outsuffix=!CONCAT('_rep',!cnt)/.
      DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
      !IF (!cnt=1 !AND !matchby~=!NULL) !THEN
         SORT CASES BY !matchby.
      !IFEND
      MATCH FILES FILE=* /FILE=mcr_bifie_newestimates !IF (!matchby~= !NULL) !THEN /BY !matchby !IFEND.
      DATASET CLOSE mcr_bifie_newestimates.
*korrigiere fehlende Kategorien.
       !IF (!quick='yes' !AND !nmi>1) !THEN
          DO IF (mcr_bifie_micnt = 1 & MISSING(!CONCAT('cnt',!CONCAT('_rep',!cnt)))).
              COMPUTE !CONCAT('cnt',!CONCAT('_rep',!cnt)) = 0.
          END IF.
          DO IF (mcr_bifie_micnt = 1 & MISSING(!CONCAT('pct',!CONCAT('_rep',!cnt)))).
              COMPUTE !CONCAT('pct',!CONCAT('_rep',!cnt)) = 0.
          END IF.
          DO IF (mcr_bifie_micnt = 1 & MISSING(!CONCAT('validpct',!CONCAT('_rep',!cnt)))).
              COMPUTE !CONCAT('validpct',!CONCAT('_rep',!cnt)) = 0.
          END IF.
          EXECUTE.
       !IFEND
       !IF (!quick~='yes') !THEN
          DO IF (MISSING(!CONCAT('cnt',!CONCAT('_rep',!cnt)))).
              COMPUTE !CONCAT('cnt',!CONCAT('_rep',!cnt)) = 0.
          END IF.
          DO IF (MISSING(!CONCAT('pct',!CONCAT('_rep',!cnt)))).
              COMPUTE !CONCAT('pct',!CONCAT('_rep',!cnt)) = 0.
          END IF.
          DO IF (MISSING(!CONCAT('validpct',!CONCAT('_rep',!cnt)))).
              COMPUTE !CONCAT('validpct',!CONCAT('_rep',!cnt)) = 0.
          END IF.
          EXECUTE.
       !IFEND
   !DOEND

   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET CLOSE mcr_bifie_data_justone.
   !IFEND
!IFEND

!LET !coeffs = 'cnt pct validpct'

* Berechne Sampling Variance (if any).
!mcr_bifie_calcsampvar
   nrep = !nrep/
   method = !method/
   fay = !fay/
   coeffs = !coeffs/.

* Berechne MI-Variance (if any) und uebertrage.
!mcr_bifie_calcmivar
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/
   breakvars = varname !plaingrp category.

* Addiere die Varianzquellen und ziehe die Wurzel fuer den Standardfehler.
!mcr_bifie_calcse
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Ergaenze Information zu Fallzahlen.
!mcr_bifie_countn
   wgt=!wgt/
   nmi=!nmi/
   vars=!plainvars/
   grp=!plaingrp/
   miss=pair/.

* Output.
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
DATASET DECLARE mcr_bifie_tmp.
AGGREGATE
   /OUTFILE=mcr_bifie_tmp
   !IF (!grp~=!NULL) !THEN
      /BREAK=!plaingrp
   !IFEND
   /n=MEAN(n)
   /nu=MEAN(nu)
   .
DATASET ACTIVATE mcr_bifie_tmp WINDOW=ASIS.
FORMATS nu (F20.1).
SUMMARIZE
   /TABLES=
      !DO !gr !IN (!grp)
         !gr
      !DOEND
      n
      nu
   /TITLE='Weighted and unweighted case count (per group)'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
FORMATS pct validpct (F20.4).
FORMATS cnt_se pct_se validpct_se (F20.6).
!IF (!nmi>1) !THEN
   FORMATS cnt_varmi pct_varmi validpct_varmi (F20.6). 
!IFEND
!IF (!nrep>1) !THEN
   FORMATS cnt_varrep pct_varrep validpct_varrep (F20.6).
!IFEND
!IF (!nmi>1 !AND !nrep>1) !THEN
   FORMATS cnt_df pct_df validpct_df (F20.2).
   FORMATS cnt_lower pct_lower validpct_lower (F20.4).
   FORMATS cnt_upper pct_upper validpct_upper (F20.4).
   FORMATS cnt_fracmiss pct_fracmiss validpct_fracmiss (F20.2).
!IFEND
DATASET CLOSE mcr_bifie_tmp.
SORT CASES BY varname !grp category.
!DO !var !IN (!plainvars)
   COMPUTE filter$ = (varname=!QUOTE(!var)).
   EXECUTE.
   FILTER BY filter$.
   SUMMARIZE
      /TABLES=
         !grp
         category
         !DO !coeff !IN (!coeffs)
            !coeff
            !IF (!showvariances='yes') !THEN
               !IF (!nmi>1) !THEN !CONCAT(!coeff,'_varmi') !IFEND
               !IF (!nrep>1) !THEN !CONCAT(!coeff,'_varrep') !IFEND
            !IFEND
            !CONCAT(!coeff,'_se')
            !IF (!nmi>1 !AND !nrep>1) !THEN !CONCAT(!coeff,'_df') !IFEND
            !IF (!nmi>1 !AND !nrep>1) !THEN !CONCAT(!coeff,'_lower') !IFEND
            !IF (!nmi>1 !AND !nrep>1) !THEN !CONCAT(!coeff,'_upper') !IFEND
            !IF (!nmi>1 !AND !nrep>1) !THEN !CONCAT(!coeff,'_fracmiss') !IFEND
         !DOEND
      /TITLE=!QUOTE(!CONCAT('Counts, percentages and valid percentages for ',!var,' (per group)'))
      /FORMAT=VALIDLIST NOCASENUM NOTOTAL
      /CELLS=NONE
      .
!DOEND

* Raeume zusammen.
!mcr_bifie_close
   debug=!debug/.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Mittelwertsdifferenz.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_diff (dataset=!charend('/')/
                                 dep=!charend('/')/
                                 pre=!charend('/')/
                                 diff=!charend('/')/
                                 grp=!charend('/')/
                                 wgt=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!charend('/')/
                                 presorted=!charend('/')).

!LET !meanvar = !CONCAT('mean',!outsuffix)
!LET !sdvar = !CONCAT('sd',!outsuffix)
!LET !diffvar = !CONCAT('diff',!outsuffix)
!LET !dvar = !CONCAT('d',!outsuffix)

!LET !breakvars = !NULL
!IF (!nmi>1) !THEN !LET !breakvars = 'mcr_bifie_micnt' !IFEND
!IF (!grp ~= !NULL) !THEN !LET !breakvars = !CONCAT(!breakvars,' ',!grp) !IFEND
!LET !breakvars = !CONCAT(!breakvars,' ',!pre)

DATASET ACTIVATE !dataset WINDOW=ASIS.
WEIGHT BY !wgt.
!IF (!breakvars ~= !NULL !AND !presorted~='yes') !THEN
   SORT CASES BY !breakvars.
!IFEND

COMPUTE mcr_bifie_filtervar = (!pre = !HEAD(!diff) OR !pre = !TAIL(!diff)).
EXECUTE.
FILTER BY mcr_bifie_filtervar.
AGGREGATE
   /OUTFILE=!outfile
   !IF (!breakvars ~= !NULL) !THEN
      /PRESORTED
      /BREAK=!breakvars
   !IFEND
   /!meanvar=MEAN(!dep)
   /!sdvar=SD(!dep)
   .
FILTER OFF.

DATASET ACTIVATE !outfile WINDOW=ASIS.
COMPUTE varcomp = (!sdvar**2) / 2.
EXECUTE.
!LET !breakvars = !NULL
!IF (!nmi>1) !THEN !LET !breakvars = 'mcr_bifie_micnt' !IFEND
!IF (!grp ~= !NULL) !THEN !LET !breakvars = !CONCAT(!breakvars,' ',!grp) !IFEND
AGGREGATE
   /OUTFILE=* MODE=ADDVARIABLES
   !IF (!breakvars ~= !NULL) !THEN
      /BREAK=!breakvars
   !IFEND
   /meanofmeans=MEAN(!meanvar)
   /sumofvariances=SUM(varcomp)
   .

COMPUTE !diffvar = 2*(!meanvar - meanofmeans).
COMPUTE !dvar = !diffvar / SQRT(sumofvariances).
EXECUTE.
DELETE VARIABLES varcomp meanofmeans sumofvariances.

!ENDDEFINE.

DEFINE !MEANDIFFcomplex (method = !charend("/")/
                           fay = !charend("/")/
                           wgt = !charend("/")/
                           rwgtbase = !charend("/")/
                           nrep = !charend("/")/
                           repdual = !default("no") !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           nmi = !charend("/")/
                           dep = !charend("/")/
                           pre = !charend("/")/
                           diff = !charend("/")/
                           grp = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default("no") !charend("/")/
                           debug = !default("no") !charend("/")/
                           allinone = !default("no") !charend("/")/
                           jkzone = !charend("/")/
                           jkwgt = !charend("/")).

!mcr_bifie_openfile
   path=!path/
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   debug=!debug/.

!LET !plaingrp = !NULL
!IF (!allinone~='yes' !OR !INDEX(!grp,'$')=0) !THEN
      !LET !plaingrp = !grp
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!grp,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!grp,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!grp)) !THEN
         !LET !plaingrp = !SUBSTR(!grp,1,!beforeSign)
      !ELSE
         !LET !plaingrp = !CONCAT(!SUBSTR(!grp,1,!beforeSign),!SUBSTR(!grp,!afterSign))
      !IFEND
!IFEND
!LET !plaindep = !NULL
!IF (!allinone~='yes' !OR !INDEX(!dep,'$')=0) !THEN
      !LET !plaindep = !dep
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!dep,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!dep,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!dep)) !THEN
         !LET !plaindep = !SUBSTR(!dep,1,!beforeSign)
      !ELSE
         !LET !plaindep = !CONCAT(!SUBSTR(!dep,1,!beforeSign),!SUBSTR(!dep,!afterSign))
      !IFEND
!IFEND
!LET !plainpre = !NULL
!IF (!allinone~='yes' !OR !INDEX(!pre,'$')=0) !THEN
      !LET !plainpre = !pre
!ELSE
      !LET !beforeSign = !LENGTH(!SUBSTR(!BLANKS(!INDEX(!pre,'$')), 2))
      !LET !afterSign = !LENGTH(!CONCAT(!BLANKS(!INDEX(!pre,'$')), !BLANKS(1)))
      !IF (!afterSign > !LENGTH(!pre)) !THEN
         !LET !plainpre = !SUBSTR(!pre,1,!beforeSign)
      !ELSE
         !LET !plainpre = !CONCAT(!SUBSTR(!pre,1,!beforeSign),!SUBSTR(!pre,!afterSign))
      !IFEND
!IFEND

!mcr_bifie_addmifiles
   file=!file/
   nmi=!nmi/
   allinone=!allinone/
   wgt=!wgt/
   jkzone=!jkzone/
   jkwgt=!jkwgt/
   repdual=!repdual/
   nrep=!nrep/
   rwgtbase=!rwgtbase/
   vars=!dep !pre !grp/.

DATASET DECLARE mcr_bifie_estimates.

* Berechne finale Schaetzer.
!mcr_bifie_diff
   dataset=mcr_bifie_data/
   dep=!plaindep/
   pre=!plainpre/
   diff=!diff/
   grp=!plaingrp/
   wgt=!wgt/
   nmi=!nmi/
   outfile=mcr_bifie_estimates/.

* Rechne mit den Replicate Weights (if any).
!IF (!nrep>1) !THEN
   !LET !repdataset = 'mcr_bifie_data'.
   * Falls im Quick-Modus: Nimm nur ersten MI-Datensatz.
   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET ACTIVATE mcr_bifie_data WINDOW=ASIS.
      DATASET COPY mcr_bifie_data_justone.
      DATASET ACTIVATE mcr_bifie_data_justone WINDOW=ASIS.
      SELECT IF (mcr_bifie_micnt=1).
      EXECUTE.
      !LET !repdataset = 'mcr_bifie_data_justone'.
   !IFEND
   
   !LET !matchby = !NULL
   !IF (!quick~='yes' !AND !nmi>1) !THEN !LET !matchby = 'mcr_bifie_micnt' !IFEND
   !IF (!plaingrp ~= !NULL) !THEN !LET !matchby = !CONCAT(!matchby,' ',!plaingrp) !IFEND
   !LET !matchby = !CONCAT(!matchby,' ',!plainpre)
   !DO !cnt = 1 !TO !nrep
      DATASET DECLARE mcr_bifie_newestimates.
      !mcr_bifie_diff
         dataset=!repdataset/
         dep=!plaindep/
         pre=!plainpre/
         diff=!diff/
         grp=!plaingrp/
         wgt=!CONCAT(!rwgtbase,!cnt)/
         nmi=!IF (!quick~='yes') !THEN !nmi !ELSE 0 !IFEND/
         outfile=mcr_bifie_newestimates/
         outsuffix=!CONCAT('_rep',!cnt)/
         presorted=!IF (!cnt>1) !THEN yes !ELSE no !IFEND/.
      DATASET ACTIVATE mcr_bifie_estimates WINDOW=ASIS.
      !IF (!cnt=1 !AND !matchby~=!NULL) !THEN
         SORT CASES BY !matchby.
      !IFEND
      MATCH FILES FILE=* /FILE=mcr_bifie_newestimates !IF (!matchby~= !NULL) !THEN /BY !matchby !IFEND.
      DATASET CLOSE mcr_bifie_newestimates.
   !DOEND

   !IF (!quick='yes' !AND !nmi>1) !THEN
      DATASET CLOSE mcr_bifie_data_justone.
   !IFEND
!IFEND

!LET !coeffs = 'mean sd diff d'

* Berechne Sampling Variance (if any).
!mcr_bifie_calcsampvar
   nrep = !nrep/
   method = !method/
   fay = !fay/
   coeffs = !coeffs/.

* Berechne MI-Variance (if any) und uebertrage.
!mcr_bifie_calcmivar
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/
   breakvars = !plaingrp !plainpre.

* Addiere die Varianzquellen und ziehe die Wurzel fuer den Standardfehler.
!mcr_bifie_calcse
   nmi = !nmi/
   nrep = !nrep/
   coeffs = !coeffs/.

* Ergaenze Information zu Fallzahlen.
!mcr_bifie_countn
   wgt=!wgt/
   nmi=!nmi/
   vars=!plaindep/
   grp=!plaingrp !plainpre/
   miss=pair/.

* Output.
DATASET ACTIVATE mcr_bifie_results WINDOW=ASIS.
FORMATS diff d (F20.4).
FORMATS diff_varmi d_varmi (F20.6). 
FORMATS diff_varrep d_varrep (F20.6).
FORMATS diff_se d_se (F20.6).
FORMATS diff_df d_df (F20.2).
FORMATS diff_lower d_lower (F20.4).
FORMATS diff_upper d_upper (F20.4).
FORMATS diff_p d_p (F20.4).
FORMATS diff_fracmiss d_fracmiss (F20.2).
IF (!plainpre=!HEAD(!diff)) diff = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_varmi = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_varrep = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_se = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_df = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_lower = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_upper = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_p = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) diff_fracmiss = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_varmi = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_varrep = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_se = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_df = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_lower = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_upper = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_p = $SYSMIS.
IF (!plainpre=!HEAD(!diff)) d_fracmiss = $SYSMIS.
EXECUTE.
FORMATS nu (F20.1).
SUMMARIZE
   /TABLES=
      !DO !gr !IN (!plaingrp)
         !gr
      !DOEND
      !plainpre
      n
      nu
   /TITLE='Weighted and unweighted case count (per group)'
   /FORMAT=VALIDLIST NOCASENUM NOTOTAL
   /CELLS=NONE
   .
SELECT IF (NOT(MISSING(mean))).
SUMMARIZE
  /TABLES=!plaingrp !plainpre mean sd diff !IF (!showvariances='yes') !THEN diff_varmi diff_varrep !IFEND diff_se diff_df diff_lower diff_upper diff_p diff_fracmiss
  /TITLE='Unstandardized mean difference(s)'
  /FORMAT=VALIDLIST NOCASENUM NOTOTAL
  /CELLS=NONE
  .
SUMMARIZE
  /TABLES=!plaingrp !plainpre mean sd d !IF (!showvariances='yes') !THEN d_varmi d_varrep !IFEND d_se d_df d_lower d_upper d_p d_fracmiss
  /TITLE='Standardized mean difference(s), Cohens d'
  /FORMAT=VALIDLIST NOCASENUM NOTOTAL
  /CELLS=NONE
  .

* Raeume zusammen.
!mcr_bifie_close
   debug=!debug/.

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// IN ARBEIT: Perzentile.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_percentiles (dataset=!charend('/')/
                                 var=!charend('/')/
                                 percs=!charend('/')/
                                 wgt=!charend('/')/
                                 grp=!charend('/')/
                                 nmi=!charend('/')/
                                 outfile=!charend('/')/
                                 outsuffix=!default('') !charend('/')/
                                 presorted = !default('no') !charend('/')).

!LET !breakvars = !NULL
!IF (!nmi>1) !THEN !LET !breakvars = 'mcr_bifie_micnt' !IFEND
!IF (!grp ~= !NULL) !THEN !LET !breakvars = !CONCAT(!breakvars,' ',!grp) !IFEND

DATASET ACTIVATE !dataset WINDOW=ASIS.
WEIGHT BY !wgt.
!IF (!presorted~='yes') !THEN
   SORT CASES BY !breakvars !var.
!IFEND

!LET !cntpercs = !NULL
!LET !varnames = !NULL
!DO !perc !IN (!percs)
   !LET !cntpercs = !CONCAT(!cntpercs,'I')
   !LET !varnames = !CONCAT(!varnames,' ',!var,'_',!perc)
!DOEND
!LET !cntpercs = !LENGTH(!cntpercs)

!LET !cntgrps = !NULL
!DO !gr !IN (!grp)
   !LET !cntpercs = !CONCAT(!cntpercs,'I')
!DOEND

MATRIX.

GET ALLDAT /FILE=* /VARIABLES=!wgt !grp !vars.
!IF (!nmi>1) !THEN
   GET MICNT /FILE=* /VARIABLES=mcr_bifie_micnt.
!IFEND
*Prepare matrix for save.
!IF (!grp=!NULL) !THEN
   COMPUTE estims = MAKE(1,1+!cntpercs,0).
!ELSE
   COMPUTE estims = MAKE(1,2+!cntpercs,0).
!IFEND
COMPUTE ARRIDX = 1.

!DO !cnt = 1 !TO !repeat

!IF (!nmi>1) !THEN
   COMPUTE CHOOSE = CSUM(MICNT = !cnt).
   COMPUTE DAT = ALLDAT(ARRIDX:(ARRIDX+CHOOSE-1),:).
   COMPUTE ARRIDX = ARRIDX+CHOOSE.
!ELSE
   COMPUTE DAT = ALLDAT.
!IFEND

COMPUTE CURGRP = DAT(
LOOP J = 1 TO NROW(DAT).

*Store the estimates.
COMPUTE estims = { estims; { !cnt, CURGRP, percentils } }.

END LOOP.

!DOEND

*Save the estimates.
SAVE estims /OUTFILE=* /VARIABLES=mcr_bifie_micnt !grp !varnames.
END MATRIX.

DATASET NAME !outfile.
!IF (!outsuffix~=!NULL) !THEN
   !DO !varname !IN (!varnames)
      RENAME VARIABLES (!varname=!CONCAT(!varname,!outsuffix)).
   !DOEND
!IFEND

!ENDDEFINE.

*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.
*///// Wrapper.
*/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////.

DEFINE !mcr_bifie_writesettings (dataset = !charend("/")/
                           quick = !default('no') !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")/
                           wgt = !charend("/")).

!IF (!nrep~=!NULL !OR !nmi~=!NULL) !THEN
   ECHO "WARNING: User-defined settings!".
!IFEND

!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='B809I') !THEN
   ECHO "Using BIST-Baseline-8 settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   96 replications (BRR, fay=0.5) in w_fstr1 to w_fstr96".
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='B809S') !THEN
   ECHO "Using BIST-Baseline-8 settings:".
   ECHO !QUOTE(!CONCAT("   final school weight: ",!wgt)).
   ECHO "   96 replications (BRR, fay=0.5) in w_fscr1 to w_fscr96".
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='B410I') !THEN
   ECHO "Using BIST-Baseline-4 settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   132 replications (JKn) in w_fstr1 to w_fstr132".
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='B410K') !THEN
   ECHO "Using BIST-Baseline-4 settings:".
   ECHO !QUOTE(!CONCAT("   final class weight: ",!wgt)).
   ECHO "   132 replications (JKn) in w_fclr1 to w_fclr132".
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='B410S') !THEN
   ECHO "Using BIST-Baseline-4 settings:".
   ECHO !QUOTE(!CONCAT("   final school weight: ",!wgt)).
   ECHO "   132 replications (JKn) in w_fscr1 to w_fscr132".
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='TP11I') !THEN
   ECHO "Using TIMSS/PIRLS 2011 settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   75 replications (JKn) from JKZONE and JKREP".
   ECHO "   5 multiple imputations (PVs)".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='TP15I') !THEN
   ECHO "Using TIMSS/PIRLS 2015+ settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   150 replications (75 JKn) from JKZONE and JKREP".
   ECHO "   5 multiple imputations (PVs)".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='PS12I') !THEN
   ECHO "Using PISA 2012 settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   80 replications (BRR, fay=0.5) from W_FSTR1 to W_FSTR80".
   ECHO "   5 multiple imputations (PVs)".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M812I') !THEN
   ECHO "Using BIST-M812I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M812S') !THEN
   ECHO "Using BIST-M812S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M413I') !THEN
   ECHO "Using BIST-M413I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M413K') !THEN
   ECHO "Using BIST-M413K settings:".
   ECHO !QUOTE(!CONCAT("   equal class weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M413S') !THEN
   ECHO "Using BIST-M413S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='E813I') !THEN
   ECHO "Using BIST-E813I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='E813S') !THEN
   ECHO "Using BIST-E813S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='D415I') !THEN
   ECHO "Using BIST-D415I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='D415S') !THEN
   ECHO "Using BIST-D415S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='D816I') !THEN
   ECHO "Using BIST-D816I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='D816S') !THEN
   ECHO "Using BIST-D816S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M817I') !THEN
   ECHO "Using BIST-M817I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M817S') !THEN
   ECHO "Using BIST-M817S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M418I') !THEN
   ECHO "Using BIST-M418I settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M418K') !THEN
   ECHO "Using BIST-M418K settings:".
   ECHO !QUOTE(!CONCAT("   equal class weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='M418S') !THEN
   ECHO "Using BIST-M418S settings:".
   ECHO !QUOTE(!CONCAT("   equal school weight: ",!wgt)).
   ECHO "   10 multiple imputations".
!IFEND
!IF (!nrep=!NULL !AND !nmi=!NULL !AND !dataset='SUFS1I') !THEN
   ECHO "Using FDB-SUF-S1 (individuals) settings:".
   ECHO !QUOTE(!CONCAT("   final student weight: ",!wgt)).
   ECHO "   430 replications (215 JKn) from jkzone and jkrep".
   ECHO "   10 multiple imputations".
!IFEND

*Warne bei Quick-Einstellung.
!IF (!quick='yes') !THEN
   ECHO "WARNING: quick calculation (recalculate with 'quick=no' to "
               + "obtain correct standard errors)!".
!IFEND
ECHO "********************************************************************************".

!ENDDEFINE.

DEFINE !UNIVAR (dataset = !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           vars = !charend("/")/
                           grp = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default('no') !charend("/")/
                           debug = !default('no') !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")).

!LET !knowndatasets = 'B809I B809S B410I B410K B410S TP11I TP15I PS12I M812I M812S M413I M413K M413S E813I E813S D415I D415S D816I D816S M817I M817S M418I M418K M418S SUFS1I'
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      ECHO "********************************************************************************".
      ECHO !QUOTE(!CONCAT("UNIVARIATE statistics for ",!vars)).
      !IF (!grp~=!NULL) !THEN
         ECHO !QUOTE(!CONCAT("   by ",!grp)).
      !IFEND
      !LET !usewgt = 'wgtstud'
      !IF (!wgt=!NULL) !THEN
         !IF (!dataset='B809S' !OR !dataset='B410S') !THEN
            !LET !usewgt = 'wgtschool'
         !IFEND
         !IF (!dataset='B410K') !THEN
            !LET !usewgt = 'wgtclass'
         !IFEND
         !IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
            !LET !usewgt = 'konst1'
         !IFEND
         !IF (!dataset='TP11I' !OR !dataset='TP15I') !THEN
            !LET !usewgt = 'TOTWGT'
         !IFEND
         !IF (!dataset='PS12I') !THEN
            !LET !usewgt = 'W_FSTUWT'
         !IFEND
         !IF (!dataset='SUFS1I') !THEN
            !LET !usewgt = 'wgtstud_sufs1'
         !IFEND
      !ELSE
         !LET !usewgt = !wgt
      !IFEND
      !mcr_bifie_writesettings
         dataset = !dataset/
         quick = !quick/
         nmi = !nmi/
         nrep = !nrep/
         wgt = !usewgt/.
   !IFEND
!DOEND

!IF (!dataset='B809I') !THEN
    !UNIVARcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B809S') !THEN
    !UNIVARcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410I') !THEN
    !UNIVARcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410K') !THEN
    !UNIVARcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fclr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410S') !THEN
    !UNIVARcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='TP11I') !THEN
    !UNIVARcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='TP15I') !THEN
    !UNIVARcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=150/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='PS12I') !THEN
    !UNIVARcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=W_FSTR/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=80/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
!IFEND
!IF (!dataset='M812I' !OR !dataset='M413I' !OR !dataset='E813I' !OR !dataset='D415I' !OR !dataset='D816I' !OR !dataset='M817I' !OR !dataset='M418I') !THEN
    !UNIVARcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
    !UNIVARcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='SUFS1I') !THEN
    !UNIVARcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=430/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=215/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
      allinone=no/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      path=!path/
      file=!file/
      vars=!vars/
      grp=!grp/
      quick=!quick/
      showvariances=!showvariances/
      debug=!debug/.      
   !IFEND
!DOEND

!ENDDEFINE.

DEFINE !CORREL (dataset = !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           vars = !charend("/")/
                           sel = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default('no') !charend("/")/
                           debug = !default('no') !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")).

!LET !knowndatasets = 'B809I B809S B410I B410K B410S TP11I TP15I PS12I M812I M812S M413I M413K M413S E813I E813S D415I D415S D816I D816S M817I M817S M418I M418K M418S SUFS1I'
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      ECHO "********************************************************************************".
      ECHO !QUOTE(!CONCAT("CORRELATIONS for ",!vars)).
      !IF (!sel~=!NULL) !THEN
         ECHO !QUOTE(!CONCAT("   on cases where ",!sel)).
      !IFEND  
      !LET !usewgt = 'wgtstud'
      !IF (!wgt=!NULL) !THEN
         !IF (!dataset='B809S' !OR !dataset='B410S') !THEN
            !LET !usewgt = 'wgtschool'
         !IFEND
         !IF (!dataset='B410K') !THEN
            !LET !usewgt = 'wgtclass'
         !IFEND
         !IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
            !LET !usewgt = 'konst1'
         !IFEND
         !IF (!dataset='TP11I' !OR !dataset='TP15I') !THEN
            !LET !usewgt = 'TOTWGT'
         !IFEND
         !IF (!dataset='PS12I') !THEN
            !LET !usewgt = 'W_FSTUWT'
         !IFEND
         !IF (!dataset='SUFS1I') !THEN
            !LET !usewgt = 'wgtstud_sufs1'
         !IFEND
      !ELSE
         !LET !usewgt = !wgt
      !IFEND
      !mcr_bifie_writesettings
         dataset = !dataset/
         quick = !quick/
         nmi = !nmi/
         nrep = !nrep/
         wgt = !usewgt/.
   !IFEND
!DOEND

!IF (!dataset='B809I') !THEN
   !CORRELcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B809S') !THEN
   !CORRELcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410I') !THEN
   !CORRELcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410K') !THEN
   !CORRELcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fclr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410S') !THEN
   !CORRELcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='TP11I') !THEN
   !CORRELcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='TP15I') !THEN
   !CORRELcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=150/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='PS12I') !THEN
   !CORRELcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=W_FSTR/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=80/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
!IFEND
!IF (!dataset='M812I' !OR !dataset='M413I' !OR !dataset='E813I' !OR !dataset='D415I' !OR !dataset='D816I' !OR !dataset='M817I' !OR !dataset='M418I') !THEN
   !CORRELcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
   !CORRELcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='SUFS1I') !THEN
   !CORRELcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=430/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=215/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
      allinone=no/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      path=!path/
      file=!file/
      vars=!vars/
      sel=!sel/
      quick=!quick/
      showvariances=!showvariances/
      debug=!debug/.   
   !IFEND
!DOEND

!ENDDEFINE.

DEFINE !LINREG (dataset = !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           dep = !charend("/")/
                           pre = !charend("/")/
                           sel = !charend("/")/
                           quick = !default('no') !charend("/")/
                           stdcoeff = !default('yes') !charend("/")/
                           showvariances = !default('no') !charend("/")/
                           debug = !default('no') !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")).

!LET !knowndatasets = 'B809I B809S B410I B410K B410S TP11I TP15I PS12I M812I M812S M413I M413K M413S E813I E813S D415I D415S D816I D816S M817I M817S M418I M418K M418S SUFS1I'
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      ECHO "********************************************************************************".
      ECHO !QUOTE(!CONCAT("LINEAR REGRESSION for ",!dep," by ",!pre)).
      !IF (!sel~=!NULL) !THEN
         ECHO !QUOTE(!CONCAT("   on cases where ",!sel)).
      !IFEND     
      !LET !usewgt = 'wgtstud'
      !IF (!wgt=!NULL) !THEN
         !IF (!dataset='B809S' !OR !dataset='B410S') !THEN
            !LET !usewgt = 'wgtschool'
         !IFEND
         !IF (!dataset='B410K') !THEN
            !LET !usewgt = 'wgtclass'
         !IFEND
         !IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
            !LET !usewgt = 'konst1'
         !IFEND
         !IF (!dataset='TP11I' !OR !dataset='TP15I') !THEN
            !LET !usewgt = 'TOTWGT'
         !IFEND
         !IF (!dataset='PS12I') !THEN
            !LET !usewgt = 'W_FSTUWT'
         !IFEND
         !IF (!dataset='SUFS1I') !THEN
            !LET !usewgt = 'wgtstud_sufs1'
         !IFEND
      !ELSE
         !LET !usewgt = !wgt
      !IFEND
      !mcr_bifie_writesettings
         dataset = !dataset/
         quick = !quick/
         nmi = !nmi/
         nrep = !nrep/
         wgt = !usewgt/.
   !IFEND
!DOEND

!IF (!dataset='B809I') !THEN
   !LINREGcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B809S') !THEN
   !LINREGcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410I') !THEN
   !LINREGcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410K') !THEN
   !LINREGcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fclr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410S') !THEN
   !LINREGcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='TP11I') !THEN
   !LINREGcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='TP15I') !THEN
   !LINREGcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=150/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='PS12I') !THEN
   !LINREGcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=W_FSTR/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=80/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
!IFEND
!IF (!dataset='M812I' !OR !dataset='M413I' !OR !dataset='E813I' !OR !dataset='D415I' !OR !dataset='D816I' !OR !dataset='M817I' !OR !dataset='M418I') !THEN
   !LINREGcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
   !LINREGcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='SUFS1I') !THEN
   !LINREGcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=430/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=215/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
      allinone=no/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      path=!path/
      file=!file/
      dep=!dep/
      pre=!pre/
      sel=!sel/
      quick=!quick/
      stdcoeff=!stdcoeff/
      showvariances=!showvariances/
      debug=!debug/.
   !IFEND
!DOEND

!ENDDEFINE.

DEFINE !CROSSTAB (dataset = !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           varrow = !charend("/")/
                           varcol = !charend("/")/
                           sel = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default('no') !charend("/")/
                           debug = !default('no') !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")).

!LET !knowndatasets = 'B809I B809S B410I B410K B410S TP11I TP15I PS12I M812I M812S M413I M413K M413S E813I E813S D415I D415S D816I D816S M817I M817S M418I M418K M418S SUFS1I'
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      ECHO "********************************************************************************".
      ECHO !QUOTE(!CONCAT("CROSSTABULATION for ",!varrow," (rows) by ",!varcol," (columns)")).
      !IF (!sel~=!NULL) !THEN
         ECHO !QUOTE(!CONCAT("   on cases where ",!sel)).
      !IFEND   
      !LET !usewgt = 'wgtstud'
      !IF (!wgt=!NULL) !THEN
         !IF (!dataset='B809S' !OR !dataset='B410S') !THEN
            !LET !usewgt = 'wgtschool'
         !IFEND
         !IF (!dataset='B410K') !THEN
            !LET !usewgt = 'wgtclass'
         !IFEND
         !IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
            !LET !usewgt = 'konst1'
         !IFEND
         !IF (!dataset='TP11I' !OR !dataset='TP15I') !THEN
            !LET !usewgt = 'TOTWGT'
         !IFEND
         !IF (!dataset='PS12I') !THEN
            !LET !usewgt = 'W_FSTUWT'
         !IFEND
         !IF (!dataset='SUFS1I') !THEN
            !LET !usewgt = 'wgtstud_sufs1'
         !IFEND
      !ELSE
         !LET !usewgt = !wgt
      !IFEND
      !mcr_bifie_writesettings
         dataset = !dataset/
         quick = !quick/
         nmi = !nmi/
         nrep = !nrep/
         wgt = !usewgt/.
   !IFEND
!DOEND

!IF (!dataset='B809I') !THEN
   !CROSSTABcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B809S') !THEN
   !CROSSTABcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410I') !THEN
   !CROSSTABcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410K') !THEN
   !CROSSTABcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fclr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410S') !THEN
   !CROSSTABcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='TP11I') !THEN
   !CROSSTABcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='TP15I') !THEN
   !CROSSTABcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=150/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='PS12I') !THEN
   !CROSSTABcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=W_FSTR/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=80/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
!IFEND
!IF (!dataset='M812I' !OR !dataset='M413I' !OR !dataset='E813I' !OR !dataset='D415I' !OR !dataset='D816I' !OR !dataset='M817I' !OR !dataset='M418I') !THEN
   !CROSSTABcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
   !CROSSTABcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='SUFS1I') !THEN
   !CROSSTABcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=430/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=215/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
      allinone=no/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      path=!path/
      file=!file/
      varrow=!varrow/
      varcol=!varcol/
      sel=!sel/
      quick=!quick/
      showvariances=!showvariances/
      debug=!debug/.
   !IFEND
!DOEND

!ENDDEFINE.

DEFINE !FREQ (dataset = !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           vars = !charend("/")/
                           grp = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default('no') !charend("/")/
                           debug = !default('no') !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")).

!LET !knowndatasets = 'B809I B809S B410I B410K B410S TP11I TP15I PS12I M812I M812S M413I M413K M413S E813I E813S D415I D415S D816I D816S M817I M817S M418I M418K M418S SUFS1I'
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      ECHO "********************************************************************************".
      ECHO !QUOTE(!CONCAT("FREQUENCIES for ",!vars)).
      !IF (!grp~=!NULL) !THEN
         ECHO !QUOTE(!CONCAT("   by ",!grp)).
      !IFEND   
      !LET !usewgt = 'wgtstud'
      !IF (!wgt=!NULL) !THEN
         !IF (!dataset='B809S' !OR !dataset='B410S') !THEN
            !LET !usewgt = 'wgtschool'
         !IFEND
         !IF (!dataset='B410K') !THEN
            !LET !usewgt = 'wgtclass'
         !IFEND
         !IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
            !LET !usewgt = 'konst1'
         !IFEND
         !IF (!dataset='TP11I' !OR !dataset='TP15I') !THEN
            !LET !usewgt = 'TOTWGT'
         !IFEND
         !IF (!dataset='PS12I') !THEN
            !LET !usewgt = 'W_FSTUWT'
         !IFEND
         !IF (!dataset='SUFS1I') !THEN
            !LET !usewgt = 'wgtstud_sufs1'
         !IFEND
      !ELSE
         !LET !usewgt = !wgt
      !IFEND
      !mcr_bifie_writesettings
         dataset = !dataset/
         quick = !quick/
         nmi = !nmi/
         nrep = !nrep/
         wgt = !usewgt/.
   !IFEND
!DOEND

!IF (!dataset='B809I') !THEN
    !FREQcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B809S') !THEN
    !FREQcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410I') !THEN
    !FREQcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410K') !THEN
    !FREQcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fclr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410S') !THEN
    !FREQcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='TP11I') !THEN
    !FREQcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='TP15I') !THEN
    !FREQcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=150/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='PS12I') !THEN
    !FREQcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=W_FSTR/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=80/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
!IFEND
!IF (!dataset='M812I' !OR !dataset='M413I' !OR !dataset='E813I' !OR !dataset='D415I' !OR !dataset='D816I' !OR !dataset='M817I' !OR !dataset='M418I') !THEN
    !FREQcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
    !FREQcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='SUFS1I') !THEN
    !FREQcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=430/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=215/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
      allinone=no/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      path=!path/
      file=!file/
      vars=!vars/
      grp=!grp/
      quick=!quick/
      showvariances=!showvariances/
      debug=!debug/.
   !IFEND
!DOEND

!ENDDEFINE.

DEFINE !MEANDIFF (dataset = !charend("/")/
                           path = !charend("/")/
                           file = !charend("/")/
                           dep = !charend("/")/
                           pre = !charend("/")/
                           diff = !charend("/")/
                           grp = !charend("/")/
                           quick = !default('no') !charend("/")/
                           showvariances = !default('no') !charend("/")/
                           debug = !default('no') !charend("/")/
                           wgt = !charend("/")/
                           nrep = !charend("/")/
                           nmi = !charend("/")).

!LET !knowndatasets = 'B809I B809S B410I B410K B410S TP11I TP15I PS12I M812I M812S M413I M413K M413S E813I E813S D415I D415S D816I D816S M817I M817S M418I M418K M418S SUFS1I'
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      ECHO "********************************************************************************".
      ECHO !QUOTE(!CONCAT("MEAN DIFFERENCE of ",!dep)).
      ECHO !QUOTE(!CONCAT("   for ",!pre," (groups ",!HEAD(!diff)," and",!TAIL(!diff),")")).
      !IF (!grp~=!NULL) !THEN
         ECHO !QUOTE(!CONCAT("   by ",!grp)).
      !IFEND
      !LET !usewgt = 'wgtstud'
      !IF (!wgt=!NULL) !THEN
         !IF (!dataset='B809S' !OR !dataset='B410S') !THEN
            !LET !usewgt = 'wgtschool'
         !IFEND
         !IF (!dataset='B410K') !THEN
            !LET !usewgt = 'wgtclass'
         !IFEND
         !IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
            !LET !usewgt = 'konst1'
         !IFEND
         !IF (!dataset='TP11I' !OR !dataset='TP15I') !THEN
            !LET !usewgt = 'TOTWGT'
         !IFEND
         !IF (!dataset='PS12I') !THEN
            !LET !usewgt = 'W_FSTUWT'
         !IFEND
         !IF (!dataset='SUFS1I') !THEN
            !LET !usewgt = 'wgtstud_sufs1'
         !IFEND
      !ELSE
         !LET !usewgt = !wgt
      !IFEND
      !mcr_bifie_writesettings
         dataset = !dataset/
         quick = !quick/
         nmi = !nmi/
         nrep = !nrep/
         wgt = !usewgt/.
   !IFEND
!DOEND

!IF (!dataset='B809I') !THEN
   !MEANDIFFcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B809S') !THEN
   !MEANDIFFcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=96/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410I') !THEN
   !MEANDIFFcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410K') !THEN
   !MEANDIFFcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fclr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='B410S') !THEN
   !MEANDIFFcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fscr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=132/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='TP11I') !THEN
   !MEANDIFFcomplex
      method=JKK/
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='TP15I') !THEN
   !MEANDIFFcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=150/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=75/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!IF (!dataset='PS12I') !THEN
   !MEANDIFFcomplex
      method=BRR/
      fay=0.5/
      wgt=!usewgt/
      rwgtbase=W_FSTR/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=80/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=5/ !IFEND
      allinone=yes/
!IFEND
!IF (!dataset='M812I' !OR !dataset='M413I' !OR !dataset='E813I' !OR !dataset='D415I' !OR !dataset='D816I' !OR !dataset='M817I' !OR !dataset='M418I') !THEN
   !MEANDIFFcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='M812S' !OR !dataset='M413K' !OR !dataset='M413S' !OR !dataset='E813S' !OR !dataset='D415S' !OR !dataset='D816S' !OR !dataset='M817S' !OR !dataset='M418K' !OR !dataset='M418S') !THEN
   !MEANDIFFcomplex
      method=JKK/
      wgt=!usewgt/
      nrep=0/
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
!IFEND
!IF (!dataset='SUFS1I') !THEN
   !MEANDIFFcomplex
      method=JKK/
      !IF (!nrep~=!NULL) !THEN fay=!NULL/ !ELSE fay=0.5/ !IFEND
      wgt=!usewgt/
      rwgtbase=w_fstr/
      !IF (!nrep~=!NULL) !THEN nrep=!nrep/ !ELSE nrep=430/ !IFEND
      !IF (!nrep~=!NULL) !THEN repdual=0/ !ELSE repdual=215/ !IFEND
      !IF (!nmi~=!NULL) !THEN nmi=!nmi/ !ELSE nmi=10/ !IFEND
      allinone=no/
      jkzone=JKZONE/
      jkwgt=JKREP/
!IFEND
!DO !onedataset !IN (!knowndatasets)
   !IF (!onedataset=!dataset) !THEN
      path=!path/
      file=!file/
      dep=!dep/
      pre=!pre/
      diff=!diff/
      grp=!grp/
      quick=!quick/
      showvariances=!showvariances/
      debug=!debug/.
   !IFEND
!DOEND

!ENDDEFINE.


